/** 
 * TPIP Basic Library 
 * @file time_meas.cpp
 * @brief TPIP Basic ֐FԌv
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 1.01 : 2009/01/27 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
//
// ver 1.01 fXgN^̃
#include "time_meas_base.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉

/** RXgN^@ړϗpobt@i[o(m_avr)
 */
TM::TM()
{
	m_avr = NULL;
	memset(nm, 0, sizeof(nm));
}

/** fXgN^@ړϗpobt@̃
 */
TM::~TM()
{
	if (m_avr)  delete m_avr;	// [ver 1.01] 
}

/**@Ԍv@
 * @param mx : ړς̍ő
 */
void TM::init(int mx)
{
	m_avr = new MV_avr;
	if (m_avr) {
		m_avr->init(mx);
		TM_min = 0xffffffff;
		TM_max = 0;
		TM_ave = 0;
		TM_now = 0;
		TM_prev = 0;
	}
}

void TM::init(int mx, char* name)
{
	strcpy(nm, name);
	m_avr = new MV_avr;
	if (m_avr) {
		m_avr->init(mx);
		TM_min = 0xffffffff;
		TM_max = 0;
		TM_ave = 0;
		TM_now = 0;
		TM_prev = 0;
	}
}

/**@Ԍv@X^[g
*/
void TM::Start()
{
	TM_prev = timeGetTime();
}

/**  Ԍv@Gh
*/
void TM::End()
{
	if (TM_prev == 0)  return ;

	TM_now = timeGetTime() - TM_prev ;
	TM_min = min(TM_min, TM_now);
	TM_max = max(TM_max, TM_now);
	TM_ave = m_avr->cal(TM_now);
}

/**  Ԍv@Zbgf[^
*/
void TM::Set(int val)
{
	TM_now = val ;
	TM_min = min(TM_min, TM_now);
	TM_max = max(TM_max, TM_now);
	TM_ave = m_avr->cal(TM_now);
}

/*@Ԍvl@NA
*/
void TM::Clr()
{
		TM_min = 0xffffffff;
		TM_max = 0;
		TM_ave = 0;
		TM_now = 0;
		TM_prev = 0;
}

/** Ԍvl \
 * @param hDC : handle to device context
 * @param x,y : \ʒu(x,y)
*/
void TM::dsp_time(HDC hDC, int x, int y)
{
	char	Msg[256] ;

	wsprintf(Msg,"Min:%4d  Max:%4d  Ave:%4d ", TM_min, TM_max, TM_ave);
	TextOut(hDC, x, y, Msg, lstrlen(Msg));

	wsprintf(Msg,"Now:%4d ", TM_now);
	TextOut(hDC, x, y+20, Msg, lstrlen(Msg));
}

/** Ԍvl \iv́j
 * @param hDC : handle to device context
 * @param x,y : \ʒu(x,y)
 * @param str : v
*/
void TM::dsp_time(HDC hDC, int x, int y, char *str)
{
	char	Msg[256] ;

	if (str) TextOut(hDC, x, y, str, lstrlen(str));
	else TextOut(hDC, x, y, nm, lstrlen(nm));

	wsprintf(Msg,"Min:%4d  Max:%4d  Ave:%4d ", TM_min, TM_max, TM_ave);
	TextOut(hDC, x, y+20, Msg, lstrlen(Msg));

	wsprintf(Msg,"Now:%4d ", TM_now);
	TextOut(hDC, x, y+40, Msg, lstrlen(Msg));
}

/** Ԍvl \iJPEG data sizej
 * @param hDC : handle to device context
 * @param x,y : \ʒu(x,y)
 * @param JPEG_size : JPEG data size
 */
void TM::dsp_time(HDC hDC, int x, int y, int JPEG_size)
{
	char	Msg[256] ;

	wsprintf(Msg,"Min:%4d  Max:%4d  Ave:%4d ", TM_min, TM_max, TM_ave);
	TextOut(hDC, x, y, Msg, lstrlen(Msg));

	wsprintf(Msg,"Now:%4d ", TM_now);
	TextOut(hDC, x, y+20, Msg, lstrlen(Msg));

	wsprintf(Msg,"JPEG size:%5d ",JPEG_size);
	TextOut(hDC, x+100, y+40, Msg, lstrlen(Msg));
}

/** Ԍvl \iJPEG data size { v́j
 * @param hDC : handle to device context
 * @param x,y : \ʒu(x,y)
 * @param JPEG_size : JPEG data size
 * @param str : v
*/
void TM::dsp_time(HDC hDC, int x, int y, int JPEG_size, char *str)
{
	char	Msg[256] ;

	TextOut(hDC, x, y, str, lstrlen(str));

	wsprintf(Msg,"Min:%4d  Max:%4d  Ave:%4d ", TM_min, TM_max, TM_ave);
	TextOut(hDC, x, y+20, Msg, lstrlen(Msg));

	wsprintf(Msg,"Now:%4d ", TM_now);
	TextOut(hDC, x, y+40, Msg, lstrlen(Msg));

	wsprintf(Msg,"JPEG size:%5d ",JPEG_size);
	TextOut(hDC, x+100, y+40, Msg, lstrlen(Msg));
}
