/** 
 * @file  RS_trace.cpp
 * @brief RS232ʐMg[XEvO module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#include <windows.h>
#include "COM_trace.h"


/** ʐMtrace NX
 * @fn     COM_trace::COM_trace(void)
 *
 */
COM_trace::COM_trace(void)
{
	buf_sz = 0;
	indx   = 0;
	cnt    = 0;
	tr_buf = NULL;
}

/** ʐMtrace NX
 * @fn     COM_trace::~COM_trace(void)
 *
 */
COM_trace::~COM_trace(void)
{
	if (tr_buf) delete (tr_buf);
}

/** ʐMtrace NX
 * @fn     void COM_trace::init( int sz )
 * @param  sz : trace buffer size
 *
 */
void COM_trace::init( int sz )
{
	buf_sz = sz;
	tr_buf = new ( TRACE_DT[buf_sz] );
}

/** ʐMtrace data i[
 * @fn     void COM_trace::put_data( unsigned char atr, unsigned char dt )
 * @param  atr : attribute
 * @param  dt  : trace data
 *
 */
void COM_trace::put_data( unsigned char atr, unsigned char dt )
{
	tr_buf[indx] = ( (atr << 8) | dt);
	indx = (indx + 1)% buf_sz;
	if( buf_sz > cnt ) cnt++ ;
}

/** ʐMtrace data i[
 * @fn     int COM_trace::getm_data( TRACE_DT* ptr, int n )
 * @param  ptr : data buffer pointer 
 * @param  n   : request count
 * @retval     : actual count
 *
 */
int COM_trace::getm_data( TRACE_DT* ptr, int n )
{
	int i,w_ix;

	if ( n > cnt ) n = cnt;
	w_ix = (indx + (buf_sz - n))% buf_sz ;

	for ( i = 0 ; i < n ; i++ )
	{
		ptr[i] = tr_buf[w_ix];
		w_ix = (w_ix + 1)% buf_sz;
	}
	return (n);
}