/** 
 * @file  Dsp_7seg.cpp
 * @brief VZO\Tu[` module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include <windows.h>


/** VZO P \֐
 * @fn     void DisplayDigit (HDC hdc, int iNumber)
 * @param  hdc     : device context
 * @param  iNumber : ID(0 ` 9)
 *
 */
static void DisplayDigit (HDC hdc, int iNumber)
{
     static BOOL  fSevenSegment [10][7] = {
                         1, 1, 1, 0, 1, 1, 1,     // 0
                         0, 0, 1, 0, 0, 1, 0,     // 1
                         1, 0, 1, 1, 1, 0, 1,     // 2
                         1, 0, 1, 1, 0, 1, 1,     // 3
                         0, 1, 1, 1, 0, 1, 0,     // 4
                         1, 1, 0, 1, 0, 1, 1,     // 5
                         1, 1, 0, 1, 1, 1, 1,     // 6
                         1, 0, 1, 0, 0, 1, 0,     // 7
                         1, 1, 1, 1, 1, 1, 1,     // 8
                         1, 1, 1, 1, 0, 1, 1 } ;  // 9
     static POINT ptSegment [7][6] = {
                          7,  6,  11,  2,  31,  2,  35,  6,  31, 10,  11, 10,
                          6,  7,  10, 11,  10, 31,   6, 35,   2, 31,   2, 11,
                         36,  7,  40, 11,  40, 31,  36, 35,  32, 31,  32, 11,
                          7, 36,  11, 32,  31, 32,  35, 36,  31, 40,  11, 40,
                          6, 37,  10, 41,  10, 61,   6, 65,   2, 61,   2, 41,
                         36, 37,  40, 41,  40, 61,  36, 65,  32, 61,  32, 41,
                          7, 66,  11, 62,  31, 62,  35, 66,  31, 70,  11, 70 } ;
     int          iSeg ;
     
     for (iSeg = 0 ; iSeg < 7 ; iSeg++)
          if (fSevenSegment [iNumber][iSeg])
               Polygon (hdc, ptSegment [iSeg], 6) ;
		  OffsetWindowOrgEx (hdc, -42, 0, NULL) ;
}

/** VZO R":" \֐
 * @fn     void DisplayColon (HDC hdc)
 * @param  hdc     : device context
 *
 */
static void DisplayColon (HDC hdc)
{
     POINT ptColon [2][4] = { 4,  21, 10,  15,  16, 21, 10, 27,
                              4,  51, 10,  45,  16, 51, 10, 57 } ;

     Polygon (hdc, ptColon [0], 4) ;
     Polygon (hdc, ptColon [1], 4) ;

     OffsetWindowOrgEx (hdc, -20, 0, NULL) ;
}

/** VZO hbg"." \֐
 * @fn     void DisplayDot (HDC hdc)
 * @param  hdc     : device context
 *
 */
static void DisplayDot (HDC hdc)
{
     POINT ptDot [4] = { 4,  51, 10,  45,  16, 51, 10, 57 } ;

     Polygon (hdc, ptDot , 4) ;

     OffsetWindowOrgEx (hdc, -20, 0, NULL) ;
}

/** VZO  \֐
 * @fn     void Dsp_7seg(HDC hdc ,char* Msg ,int Msg_cont ,int ox ,int oy ,int wx ,int wy,HBRUSH hBrush)
 * @param  hdc      : device context
 * @param  Msg      : \̃|C^@\FAR(:)Ahbg(.)
 * @param  Msg_cont : \
 * @param  ox       : \ʒuij
 * @param  oy       : \ʒuij
 * @param  wx       : \
 * @param  wy       : \
 * @param  hBrush   : \F(uVFhandle)
 *
 */
void Dsp_7seg(HDC hdc ,char* Msg ,int Msg_cont ,int ox ,int oy ,int wx ,int wy,HBRUSH hBrush)
{
	int old_MapMode ;
	HBRUSH old_Brush;
	HPEN   old_Pen ;
	char code ;
	int i ;

	old_MapMode = SetMapMode (hdc, MM_ANISOTROPIC);
	SetWindowExtEx (hdc, 276, 72, NULL) ;
	SetWindowOrgEx (hdc, 0, 0, NULL) ;
	SetViewportExtEx (hdc, (wx*7)/4, wy, NULL) ;

	SetViewportOrgEx (hdc, ox, oy, NULL) ;

	old_Pen   =(HPEN)SelectObject (hdc, GetStockObject (NULL_PEN)) ;
	old_Brush =(HBRUSH)SelectObject (hdc, hBrush) ;

	for ( i = 0 ; i < Msg_cont ; i++)
	{
		code = Msg[i] ;
		switch (code)
		{
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			DisplayDigit (hdc, code-0x30 ) ;
			break ;
		case ' ':
			OffsetWindowOrgEx (hdc, -42, 0, NULL) ;
			break ;
		case ':':
			DisplayColon (hdc) ;
			break ;
		case '.':
			DisplayDot (hdc) ;
			break ;
		}
	}

	SetMapMode(hdc, old_MapMode) ;
	SetWindowOrgEx (hdc, 0, 0, NULL) ;
	SetViewportOrgEx (hdc, 0, 0, NULL) ;
	SelectObject(hdc , old_Brush) ;
	SelectObject(hdc , old_Pen) ;
}
