/** 
 * @file  Dsp_Input.cpp
 * @brief XR(RRC)po͕\Tu[` module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.01 : 2009/06/10 katayama
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3) 
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#define WINVER 0x0500
#include <windows.h>
#include "def_dev.h"
#include "dev_ctrl.h"
#include "IO_ctrl.h"
#include "IO_symbl.h"
#include "Dsp_Input.h"
#include "UDP_com.h"

/** rbg\p@Tu[` in bit ϐrbgPʂɕ\j
 *  static void dsp_bit(HDC hdc, int x, int y, int bit, int n)
 * @param  hdc     : handle of device context@
 * @param  x       : \ʒuij
 * @param  y       : \ʒuij
 * @param  bit     : rbg\ 32bitϐl
 * @param  n       : \rbg
 */
static void dsp_bit(HDC hdc, int x, int y, int bit, int n)
{
	int ptn;
	char* msg;

	ptn = 0x01 << (n-1);
	for (int i = 0 ; i < n ; i++) {
		msg = "- ";
		if ( bit & ptn ) msg = "O ";
		TextOut( hdc, x+i*8, y, msg , 2);
		ptn = ptn >> 1;
	}
}



/** Joystick & control output(MT/PWM/DO) \֐
 * @fn     void Dsp_Joy(HDC hdc, int x, int y)
 * @param  hdc : device context
 * @param  x   : \ʒuij
 * @param  y   : \ʒuij
 *
 */

void Dsp_Joy(HDC hdc, int x, int y)
{
	COLORREF c_tbl[] =	{RGB( 255,  80,  80),	// MT
						 RGB(   0, 255,  80),	// VSEL
						 RGB(   0, 150, 255),	// VGA
						 RGB( 180,   0, 255),	// MODE
						 RGB( 255, 255,   0)};	// DO
	VIEW_t   v;
	IO_ctrl* p;
	COLORREF rtn_cl;
	int		i,j;
	char	Msg[256] ;
	int		btn;
	int		mask;
	char*    mk;

// Display Joystick data
	// Axis 1 - 4
	j= 0;
	for ( i = 0; i < 4 ; i++ )
	{	
		if ((p = get_in_dev_ptr(j)) == NULL) {
			SetTextColor(hdc, RGB( 100, 50, 0));
			wsprintf(Msg,"AXIS %1d :%6d  ", i, ps2.axis[i]);
		}
		else {
			SetTextColor(hdc, RGB( 255, 150, 0));
			wsprintf(Msg,"%8s :%6d  ", p->get_dev_nm(), p->get_vol());
		}
		TextOut(hdc, x+i*100, y, Msg, lstrlen(Msg));
		j++;
	}

	// Axis 5 - 8
	for ( i = 0; i < 4 ; i++ )
	{
		if ((p = get_in_dev_ptr(j)) == NULL) {
			SetTextColor(hdc, RGB( 100, 50, 0));
			wsprintf(Msg,"AXIS %1d :%6d  ", i+4, ps2.axis[i+4]);
		}
		else {
			SetTextColor(hdc, RGB( 255, 150, 0));
			wsprintf(Msg,"%8s :%6d  ", p->get_dev_nm(),p->get_vol());
		}
		TextOut(hdc, x+i*100, y+18, Msg, lstrlen(Msg));
		j++;
	}

	// button
	SetTextColor(hdc, RGB( 255, 150, 0));
	btn  = ps2.BTN_bit;
	mask = 0x01;
	for (i = 0 ; i < 20 ; i++)		// ps2 button bit
	{
		mk = " - ";
		if ( btn & mask) mk = " O ";
		wsprintf(Msg," %s  " , mk );
		TextOut(hdc, x+i*24, y+40, Msg, lstrlen(Msg));
		mask = mask << 1;
	}
	rtn_cl = SetTextColor(hdc, RGB( 0, 255, 0));
	for (i = 0 ; i < 16 ; i++)		// button named
	{
		p = get_in_dev_ptr(BUTT_TOP_POS+i);
		if ( p != 0 ) {
			p->view( &v );
			if ( v.vol ) SetTextColor(hdc, RGB( 0, 255, 0));
			else SetTextColor(hdc, RGB( 0, 80, 0));	
			wsprintf(Msg," %s  " , v.dev_if.name );
			TextOut(hdc, x+i*24, y+55, Msg, lstrlen(Msg));
		}

	}

	// POV
	SetTextColor(hdc, RGB( 255, 150, 0));
	btn  = ps2.POV_bit;
	mask = 0x01;
	for (i = 0 ; i < 16 ; i++)		// ps2 button bit
	{
		mk = " - ";
		if ( btn & mask) mk = " O ";
		wsprintf(Msg," %s  " , mk );
		TextOut(hdc, x+i*24, y+75, Msg, lstrlen(Msg));
		mask = mask << 1;
	}
	rtn_cl = SetTextColor(hdc, RGB( 0, 255, 0));
	for (i = 0 ; i < 16 ; i++)		// button named
	{
		p = get_in_dev_ptr(POV_TOP_POS+i);
		if ( p != 0 ) {
			p->view( &v );
			if ( v.vol ) SetTextColor(hdc, RGB( 0, 255, 0));
			else SetTextColor(hdc, RGB( 0, 80, 0));	
			wsprintf(Msg," %s  " , v.dev_if.name );
			TextOut(hdc, x+i*24, y+90, Msg, lstrlen(Msg));
		}

	}

// Display control output data
	// PWM1 - 5
	SetTextColor(hdc, RGB( 200, 255, 255));
	for ( i = 0 ; i < 5 ; i++ )
	{
		p = get_out_dev_ptr(i);
		if ( p != 0 ) {
			p->view( &v );
			wsprintf(Msg,"%s: %3d (%d)  ",v.dev_if.name, v.vol, v.mode );
			TextOut(hdc, x+i*100+510, y+00, Msg, lstrlen(Msg));

			wsprintf(Msg," [%3d, %3d] ", v.min, v.max );
			TextOut(hdc, x+i*100+510, y+15, Msg, lstrlen(Msg));
		}
	}


    // PWM6 - 10
	for ( i = 0 ; i < 5 ; i++ )
	{
		p = get_out_dev_ptr(i+5);
		if ( p != 0 ) {
			p->view( &v );
			wsprintf(Msg,"%s: %3d (%d)  ",v.dev_if.name, v.vol, v.mode );
			TextOut(hdc, x+i*100+510, y+35, Msg, lstrlen(Msg));

			wsprintf(Msg," [%3d, %3d] ", v.min, v.max );
			TextOut(hdc, x+i*100+510, y+50, Msg, lstrlen(Msg));
		}
	}

	// MT VSEL VGA MODE
	for ( i = 0 ; i < 3 ; i++ )
	{
		p = get_out_dev_ptr(i+21);
		if ( p != 0 ) {
			p->view( &v );
			SetTextColor(hdc, c_tbl[i]);
			wsprintf(Msg,"%s: %3d (%d)  ",v.dev_if.name, v.vol, v.mode );
			TextOut(hdc, x+i*100+610, y+75, Msg, lstrlen(Msg));

			wsprintf(Msg," [%3d, %3d] ", v.min, v.max );
			TextOut(hdc, x+i*100+610, y+90, Msg, lstrlen(Msg));
		}
	}

	SetTextColor(hdc, c_tbl[4]);
	wsprintf(Msg,"DO:   " );
	TextOut(hdc, x+400+510, y+75, Msg, lstrlen(Msg));
	dsp_bit(hdc, x+400+510, y+90, d_out, 9);

	SetTextColor(hdc, rtn_cl);
}

/** SIOf[^ j^\֐
 * @fn     void Dsp_SIO_mon( HDC hdc, int x, int y )
 * @param  hdc : device context
 * @param  x   : \ʒuij
 * @param  y   : \ʒuij
 *
 */
#define TR_MAX 300
static TRACE_DT tr_dt[TR_MAX];
void Dsp_SIO_mon( HDC hdc, int x, int y )
{
	char MsgBuf[256] ;
	int i,j,indx,n;
	unsigned char atr;

	wsprintf(MsgBuf,"SIO DUMP ( UDP-SIO:%d sio speed = %dbps, COM port = %s )",udp_sio_f,sio_speed,com_port);
	TextOut(hdc, x, y, MsgBuf, lstrlen(MsgBuf));
	y = y + 20;

	if (tr==NULL) return;
	n = tr->getm_data(tr_dt,TR_MAX);
	indx = 0;
	for ( j = 0 ; j < TR_MAX/50 ; j++ )
	{
		for ( i = 0 ; i < 50 ; i++ )
		{
			if ( indx >= n ) break;
			SetBkColor(hdc, RGB(0, 0, 0));
			TextOut(hdc, x+19*i, y, "     ", 5);
			atr = (tr_dt[indx]&0xff00)>>8;
			chg_BkColor( hdc, (unsigned char) atr );
			wsprintf(MsgBuf,"%02X",( tr_dt[indx]&0xff ) );
			TextOut(hdc, x+19*i, y, MsgBuf, lstrlen(MsgBuf));
			indx++;
		}
		if (indx < n)y = y + 15;
	}
	SetBkColor(hdc, RGB(0, 0, 0));
}
