/** 
 * @file  Dsp_RRC.cpp
 * @brief XR(RRC)p\Tu[` module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.00 : 2009/04/01 katayama
 * @version 2.01 : 2009/06/09 katayama (for TPIP2)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include  <windows.h>
#include <math.h>
#include "def_dev.h"
#include "def_color.h"
#include "sub_module.h"
#include "Dsp_RRC.h"
#include "Dsp_7seg.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉

static HBRUSH brush[6];	// `l̃uVFe[u

/** `l̃uVFo֐
 * @fn     HBRUSH get_brush_color(int id)
 * @param  id  : channel No. ( 0 ` 5 )
 * @retval     : uVFHandle
 *
 */
static HBRUSH get_brush_color(int id)
{
	return( brush[(id%6)] );
}

/** IO display NX̐
 * @fn     IO_dsp::IO_dsp()
 *
 */
IO_dsp::IO_dsp()
{
	dsp_mode = 0;	// mode = BarGraph
	type  = 0;		// type = AI
	ch_no = 0;
	io_name[0] = 0;
	wide  = 100;
	height=  30;
	xs    =   0;
	ys_t  = 120;
	ys    = ys_t+17;
	xe    = xs + wide;
	ye    = ys_t + height;
	min   = 0;
	max   = 500;
	p_cnt = 3;
	dia   = 55;
	k     = (float)0.345575191;
}

/** IO display NX̏֐
 * @fn     int IO_dsp::init(int ch, char* nm)
 * @param  ch  : device channel No. ( 0 ` 4 : AI, 5 :PI )
 * @param  nm  : device name (max. 7 char)
 *
 */
int IO_dsp::init(int ch, char* nm)
{
	if (ch < 12) {	// AI
		ch_no = ch;
		type  = 0;
		dsp_mode = 0;
	}
	else {			// PI
		ch_no = ch - 12;
		type  = 1;
		dsp_mode = 1;
	}
	hBrush = get_brush_color( ch );		// uV̑I
	strncpy( io_name, nm, 8);	io_name[7] = 0;
	return 0;
}

/** IO display NX \ʒu̐ݒ֐
 * @fn     void IO_dsp::set_pos(int x,int y, int w, int h)
 * @param  x   : \ʒuixj
 * @param  y   : \ʒuiyj
 * @param  w   : \
 * @param  h   : \
 *
 */
void IO_dsp::set_pos(int x,int y, int w, int h)
{
	if (dsp_mode == 1) {
		wide  = Limit( w,40, 1000);
		height= Limit( h,40, 200);
		xs    = Limit( x, 0, 1024 - w);
		ys    = Limit( y, 0, 768 - h);
		xe    = xs + wide ;
		ye    = ys + height ;
		ys_t  = ye - 15;
	}
	else {
		wide  = Limit( w, 5, 1000);
		height= Limit( h,20, 200);
		x     = Limit( x, 0, 1024 - w);
		y     = Limit( y, 0, 768 - h);
		xs    = x ;
		ys    = y+18;
		ys_t  = y;
		xe    = xs + wide ;
		ye    = y + height ;
	}
}

/** IO display NX őŏl̐ݒ֐
 * @fn     void IO_dsp::set_minmax(int min_, int max_)
 * @param  min_  : \l̍ŏl
 * @param  max_  : \l̍ől
 *
 */
void IO_dsp::set_minmax(int min_, int max_)
{
	if (type == 1) {
		min   = Limit( min_, 0, 765);
		max   = Limit( max_, 0, 765);
	}
	else {
		min   = Limit( min_, 0, 500);
		max   = Limit( max_, 0, 500);
	}
}

/** IO display NX pX͒lԑZo萔̐ݒ֐
 * @fn     void IO_dsp::set_pi_para(int p, int d)
 * @param  p  : ^CP]̃pX
 * @param  d  : ^C̒a(mm)
 *
 */
void IO_dsp::set_pi_para(int p, int d)
{
	p_cnt = p;
	dia   = d;
	k = ((float)3.141592654 * dia * 600 / (float)( p_cnt * 10000 ));
}

/** IO display NX \l̎o֐
 * @fn     int IO_dsp::get_vol(void)
 * @retval     : \l
 *
 */
int IO_dsp::get_vol(void)
{
//	float res;
	int   res;

	if (type == 0) 	return ( AI_ch[ch_no] );
	else {
//		res = k * PI_ch[ch_no];
		res = PI_ch[ch_no];
		return((int)res);
	}
}

/** IO display NX o[Ot\֐
 * @fn     void IO_dsp::dsp_Bar_graph( HDC hdc )
 * @param  hdc : device context handle
 *
 */
void IO_dsp::dsp_Bar_graph( HDC hdc )
{
	char	Msg[64] ;
	RECT rect;
	int d;
	int num ;
	int vol;
	COLORREF old_color;

	old_color = SetTextColor(hdc, RGB(  0, 200,  0));	// FݒFlight gray

	vol = get_vol();	// \lo
	if ((blink_flg)&&(( vol < min )||( vol > max ))) SetTextColor(hdc, RGB( 255,  0,  0));	// _ŕ\
	num = rang_chg( vol, min, max, 0, 500 );	// WύX(0 ` 500)
	if (type == 0) wsprintf(Msg,"%s:%d.%02dv ", io_name, vol/100, vol%100);
	else  wsprintf(Msg,"%s:%3d.%01d kp/m ", io_name, vol/10, vol%10);	// display PI
	TextOut(hdc, xs, ys_t, Msg, lstrlen(Msg));	// \

	// o[Ot\
	d = (num * wide)/500;
	SetRect(&rect , xs, ys, xs + d, ye);
	FillRect(hdc ,&rect ,hBrush);
	SetRect(&rect , xs + d, ys, xe, ye);
	FillRect(hdc ,&rect ,hBrush_DB);
	SetRect(&rect , xs, ys, xe, ye);
	if ((blink_flg)&&(( vol < min )||( vol > max ))) FrameRect(hdc, &rect ,hBrush_R);	// _ŕ\
	else FrameRect(hdc, &rect ,hBrush_LB);

	SetTextColor(hdc, old_color);
}

/** IO display NX VZO\֐
 * @fn     void IO_dsp::dsp_7seg( HDC hdc )
 * @param  hdc : device context handle
 *
 */
void IO_dsp::dsp_7seg( HDC hdc )
{
	char	Msg[64] ;
	RECT rect;
	int num ;
	int vol;
	COLORREF old_color;

	old_color = SetTextColor(hdc, RGB( 200, 200, 200));	// FݒFlight gray

	vol = get_vol();	// \lo
	num = rang_chg( vol, min, max, 0, 500 );	// WύX(0 ` 500)
	SetRect(&rect , xs, ys, xe, ye);
	FillRect(hdc ,&rect ,hBrush_BK);
	wsprintf(Msg,"%s", io_name);
	TextOut(hdc, xs+2, ys_t, Msg, lstrlen(Msg));
	TextOut(hdc, xe-32, ys_t, "Krpm", 4);		// [Ver 2.00]
	wsprintf(Msg,"%2d.%01d", vol/10, vol%10);
	Dsp_7seg( hdc, Msg, lstrlen(Msg) , xs , ys+2, wide, height-18, hBrush_Y);	// VZO\
	FrameRect(hdc, &rect ,hBrush_LB);

	SetTextColor(hdc, old_color);
}

/** \o^̏֐
 * @fn     void dsp_entry_init()
 *
 */
void dsp_entry_init()
{
	int i;
	DSP_ent_cnt = 0;
	for ( i = 0 ; i < (int)max_dsp_no ; i++ ) dsp_dev_p[i] = 0;
	brush[0] = hBrush_DG;
	brush[1] = hBrush_RY;
	brush[2] = hBrush_Y;
	brush[3] = hBrush_Bu;
	brush[4] = hBrush_CY;
	brush[5] = hBrush_G;

}

/** \(IO display)NX̓o^֐
 * @fn     IO_dsp* ent_io_dsp()
 * @retval   : o^\NXInstance
 *
 */
IO_dsp* ent_io_dsp()
{
	IO_dsp* p;

	p = 0;
	if ( DSP_ent_cnt < (int)max_dsp_no ) {
		p = new IO_dsp;
		dsp_dev_p[DSP_ent_cnt] = p;		// \o^e[uɕ\NXo^
		if (p != 0) DSP_ent_cnt++;
	}
	return (p);
}

/** o^\NX֐
 * @fn     void dsp_relese(void)
 *
 */
void dsp_relese(void)
{
	int i;

// display table
	for ( i = 0 ; i < (int)max_dsp_no ; i++ )
	{
		if (dsp_dev_p[i] != 0 ) 
		{
			delete(dsp_dev_p[i]);	// \NX
			dsp_dev_p[i] = 0;		// o^폜
		}
	}
	DSP_ent_cnt = 0;
}

/** o^\NXgpāAꊇ\֐
 * @fn     void Dsp_AI_bar( HDC hdc )
 * @param  hdc : device context handle
 *
 */
void Dsp_AI_bar( HDC hdc )
{
	int i;

	for (i = 0 ; i < (int)max_dsp_no ; i++)
	{
		if (dsp_dev_p[i] != 0) {
			if (dsp_dev_p[i]->dsp_mode == 0)
			{
				dsp_dev_p[i]->dsp_Bar_graph( hdc );	// \[hFo[Ot
			}
			else dsp_dev_p[i]->dsp_7seg( hdc );	// \[hFVZO\
		}
	}
}
