/** 
 * @file  Dsp_proc.cpp
 * @brief \ module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.01 : 2009/06/09 katayama (for TPIP2)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include  <windows.h>
#include  <winsock.h>
#include  <stdio.h>
#include <math.h>
#include "def_dev.h"
#include "Dsp_sub.h"
#include "sub_module.h"

HBRUSH hBrush_R ;
HBRUSH hBrush_LR ;
HBRUSH hBrush_RY ;
HBRUSH hBrush_Y ;
HBRUSH hBrush_G ;
HBRUSH hBrush_Bu ;
HBRUSH hBrush_CY ;
HBRUSH hBrush_DG ;
HBRUSH hBrush_LB ;
HBRUSH hBrush_DB ;
HBRUSH hBrush_BK ;


/** \\[X@֐
 * @fn     void Init_Dsp(void)
 *
 */
void Init_Dsp(void)
{
	hBrush_R = CreateSolidBrush(RGB (255,  0,  0));
	hBrush_LR= CreateSolidBrush(RGB (255, 50, 50));
	hBrush_RY= CreateSolidBrush(RGB (255, 50,  0));
	hBrush_Y = CreateSolidBrush(RGB (255,255,  0));
	hBrush_G = CreateSolidBrush(RGB (  0,255,  0));
	hBrush_DG= CreateSolidBrush(RGB (  0,130,  0));
	hBrush_Bu= CreateSolidBrush(RGB (  0,  0,255));
	hBrush_CY= CreateSolidBrush(RGB (  0,255,255));
	hBrush_LB= CreateSolidBrush(RGB (180,200,255));
	hBrush_DB= CreateSolidBrush(RGB ( 50, 50, 50));
	hBrush_BK= CreateSolidBrush(RGB (  0,  0,  0));
	Font_init();
}

/*----------------------------------------------------
@@@@@ \\[X@
------------------------------------------------------*/
/** \\[X@֐
 * @fn     void Delete_Dsp(void)
 *
 */
void Delete_Dsp(void)
{
	Font_del();
	DeleteObject (hBrush_R) ;
	DeleteObject (hBrush_LR) ;
	DeleteObject (hBrush_RY) ;
	DeleteObject (hBrush_Y) ;
	DeleteObject (hBrush_G) ;
	DeleteObject (hBrush_DG) ;
	DeleteObject (hBrush_Bu) ;
	DeleteObject (hBrush_CY) ;
	DeleteObject (hBrush_LB) ;
	DeleteObject (hBrush_DB) ;
	DeleteObject (hBrush_BK) ;
}



/*
@@@obe[cʁ@\
 */
/** obe[cʁ@\֐
 * @fn     void Dsp_Batt(HDC hdc, int x, int y )
 * @param  hdc  : device context handle
 * @param  x    : \ʒuij
 * @param  y    : \ʒuij
 *
 */
void Dsp_Batt(HDC hdc, int x, int y )
{
#define TEXT_BAR_	// `Fɂo[Ot

	char Msg[256] ;
	int  d ;
#ifndef TEXT_BAR_
	int  Width =180 ;
#endif
#ifdef  TEXT_BAR_
	int  Width =16 ;
#endif
	int  Batt_p ;


	SelectObject(hdc, GetStockObject( SYSTEM_FIXED_FONT ));
	SetTextCharacterExtra(hdc, 3);
	SetTextColor(hdc, RGB(250, 250, 255));
	Batt_p = (100 * (Batt_v - Batt_min))/(Batt_max - Batt_min) ;

	Batt_p = Limit(Batt_p , 0, 100);
	d    = (Width * Batt_p)/ 100 ;

	wsprintf(Msg,"BATTERY :%2d.%1dV  %3d%%",Batt_v/10 ,Batt_v%10, Batt_p);
	TextOut(hdc, x, y, Msg, lstrlen(Msg));

	y = y - 21 ;

#ifndef TEXT_BAR_
	rect_Bar_graph( hdc, x, y, d);	// o[Ot(Full rect)
#endif
#ifdef  TEXT_BAR_
	text_Bar_graph( hdc, x, y, d);	// TEXT""ɂo[OtiPUiKj
#endif
	SetTextCharacterExtra(hdc, 0);


}

