/** 
 * @file  Dsp_sub.cpp
 * @brief \Tu[` module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include  <windows.h>
#include <math.h>
#include "def_dev.h"
#include "def_color.h"
#include "sub_module.h"


/** ʃNA
 * @fn     void Dsp_Clear(HDC hdc)
 * @param  hdc   : device context handle
 *
 */
void Dsp_Clear(HDC hdc)
{
	HBRUSH Old_Brush;

	Old_Brush =(HBRUSH) SelectObject(hdc , hBrush_BK);
	Rectangle (hdc, 0,0,1023,740);
	SelectObject(hdc , Old_Brush) ;

}

/** KChE}[J@\
 * @fn     void Dsp_Marker(HDC hDC, int dsp_mode ,int st,int pan)
 * @param  hDC      : device context handle
 * @param  dsp_mode : display mode
 * @param  st       : steering
 * @param  pan      : pan
 *
 */
void Dsp_Marker(HDC hDC, int dsp_mode ,int st,int pan)
{
#define WIDE_POS  210
#define HIGHT_POS 40

	HBRUSH hBrush ;
	HPEN   hPen ;
	int Old_BkMode;
	RECT rect;
	int x,y ;

	x = 512 ;
	if ((dsp_mode == 1)||(dsp_mode == 2)) x = x + st - pan ;
	y = 450;
	y = 420;

	rect.top    = y-HIGHT_POS ;
	rect.bottom = y+HIGHT_POS ;
	rect.left   = x-WIDE_POS ;
	rect.right  = x+WIDE_POS ;

	hBrush = CreateSolidBrush( RGB( 255, 0, 0) );
	hPen   = CreatePen(PS_DOT, 1, RGB( 255, 0, 0));
	SelectObject(hDC, hPen );
	Old_BkMode = SetBkMode (hDC, TRANSPARENT);
	FrameRect( hDC , &rect , hBrush );
	MoveToEx ( hDC , x-(WIDE_POS+10), y, NULL);
	LineTo   ( hDC , x+(WIDE_POS+10), y);
	MoveToEx ( hDC , x, y-(HIGHT_POS+10), NULL);
	LineTo   ( hDC , x, y+(HIGHT_POS+10));
	DeleteObject (hBrush) ;
	SetBkMode(hDC, Old_BkMode);
	DeleteObject (hPen);

}

/** "Back!!" @\
 * @fn     void Dsp_Back(HDC hDC)
 * @param  hDC   : device context handle
 *
 */
void Dsp_Back(HDC hDC)
{
	char	Msg[256] ;
	int x,y ;

	SetBkColor(hDC, RGB(255, 0, 0));
	SetTextColor(hDC, RGB(255, 255, 0));
	x = 490; y = 560;

	wsprintf(Msg,"BACK!!");
	TextOut(hDC, x+0, y, Msg, lstrlen(Msg)-1);

	SetBkColor(hDC, RGB(0, 0, 0));
}

/** W̉]
 * @fn     void RotatePoint (POINT pt[], int iNum, int iAngle)
 * @param  pt[]  : QWz
 * @param  iNum  : QWz
 * @param  iAngle: ]px(-360`360)
 *
 */
void RotatePoint (POINT pt[], int iNum, int iAngle)
{
 #define TWOPI (2 * 3.141592654)	// Q ~ ~
    int   i ;
     POINT ptTemp ;
     
     for (i = 0 ; i < iNum ; i++)
     {
          ptTemp.x = (int) (pt[i].x * cos (TWOPI * iAngle / 360) +
               pt[i].y * sin (TWOPI * iAngle / 360)) ;
          
          ptTemp.y = (int) (pt[i].y * cos (TWOPI * iAngle / 360) -
               pt[i].x * sin (TWOPI * iAngle / 360)) ;
          
          pt[i] = ptTemp ;
     }
}

/** Xs[h@[^\iPj
 * @fn     void Dsp_Speed1(HDC hdc ,int Org_x,int Org_y,int speed,int Max_Speed ,HBRUSH hBrush)
 * @param  hdc       : device context handle
 * @param  Org_x     : _WiXj
 * @param  Org_y     : _Wij
 * @param  speed     : x(Km/h)
 * @param  Max_Speed : ő呬x(Km/h)
 * @param  hBrush    : [^j̐FHandler
 *
 */
void Dsp_Speed1(HDC hdc ,int Org_x,int Org_y,int speed,int Max_Speed ,HBRUSH hBrush)
{
	static POINT pt[4] = { 3,5, 2,50,  -2,50,  -3,5 } ;
	POINT ptTemp[4] ;
	HBRUSH Old_Brush;
	HPEN   Old_Pen ;
	int i,iAngle ;

	int x,y ;

	Old_Brush =(HBRUSH) SelectObject(hdc , hBrush_LB);	// wiF
	Old_Pen   =(HPEN)   SelectObject(hdc , GetStockObject(NULL_PEN));	// ̐Fij

	Chord (hdc,Org_x,Org_y,Org_x+110,Org_y+110,Org_x+110,Org_y+100,Org_x,Org_y+100);	// [^̔wi`
	x = Org_x + 55 ;
	y = Org_y + 55 ;
	memcpy (ptTemp ,pt , sizeof(pt)) ;

	iAngle = 360-(((speed * (360-60*2))/Max_Speed)+60) ;	// j̊pxZo
	RotatePoint(ptTemp ,4 ,iAngle) ;	// j̍W]

	for (i = 0 ; i < 4 ; i++)
	{
		ptTemp[i].x = ptTemp[i].x + x ;	// X̕`ʒuAړ
		ptTemp[i].y = ptTemp[i].y + y ;	// Y̕`ʒuAړ
	}
	SelectObject(hdc , hBrush);
	Polygon(hdc ,ptTemp ,4);			// j̕`

	SelectObject(hdc, GetStockObject(BLACK_BRUSH));
	Ellipse(hdc,x-9,y-9,x+10,y+10);		// j̎~`
	SelectObject(hdc , Old_Brush) ;
	SelectObject(hdc , Old_Pen) ;
}


/** Xs[h@[^\iRj
 * @fn     void Dsp_Speed(HDC hdc ,int mode ,int Org_x,int Org_y,int speed,int Max_Speed ,HBRUSH hBrush)
 * @param  hdc       : device context handle
 * @param  mode      : \[h(0`3)
 * @param  Org_x     : _WiXj
 * @param  Org_y     : _Wij
 * @param  speed     : x(Km/h)
 * @param  Max_Speed : ő呬x(Km/h)
 * @param  hBrush    : [^j̐FHandler
 *
 */
void Dsp_Speed(HDC hdc ,int mode ,int Org_x,int Org_y,int speed,int Max_Speed ,HBRUSH hBrush)
{
	static POINT pt[][4] = {
								3,5, 2,50,  -2,50,  -3,5,	// mode = 0
								2,5, 1,65,  -1,65,  -2,5,	// mode = 1
								4,0, 1,90,  -1,90,  -4,0,	// mode = 2
								3,0, 1,65,  -1,65,  -3,0 	// mode = 3
							};
	static struct	{ int  o;   int w ;   int b ; } ang[] = {
					// SʒuAUpAoCAXp
						55,     360-60*2, 60,	// mode = 0
						80,     360-30*2, 30,	// mode = 1
						90,     180+45,   45,	// mode = 2
						65,     180+45,   45,	// mode = 3
	};
	POINT ptTemp[4] ;
	HBRUSH Old_Brush;
	HPEN   Old_Pen ;
	int i,iAngle ;

	int x,y ;


	Old_Brush =(HBRUSH) SelectObject(hdc , hBrush_LB);
	Old_Pen   =(HPEN)   SelectObject(hdc , GetStockObject(NULL_PEN));
	if (mode == 0 ) Chord (hdc,Org_x,Org_y,Org_x+110,Org_y+110,Org_x+110,Org_y+100,Org_x,Org_y+100);	// [^̔wi`

	x = Org_x + ang[mode].o ;	// [^j̉]SʒuiX)
	y = Org_y + ang[mode].o ;	// [^j̉]SʒuiY)
	memcpy (ptTemp ,pt[mode] , sizeof(pt[mode])) ;	// [hΉ̐jWZbg

	iAngle = 360-(((speed * ang[mode].w)/Max_Speed)+ang[mode].b) ;	// j̊pxZo
	RotatePoint(ptTemp ,4 ,iAngle) ;	// j̍W]

	for (i = 0 ; i < 4 ; i++)
	{
		ptTemp[i].x = ptTemp[i].x + x ;	// X̕`ʒuAړ
		ptTemp[i].y = ptTemp[i].y + y ;	// Y̕`ʒuAړ
	}
	SelectObject(hdc , hBrush);
	Polygon(hdc ,ptTemp ,4);			// j̕`
	if (mode < 2) {
		SelectObject(hdc, GetStockObject(BLACK_BRUSH));
		Ellipse(hdc,x-9,y-9,x+10,y+10);		// j̎~`
	}
	SelectObject(hdc, GetStockObject(BLACK_BRUSH));
	SelectObject(hdc , Old_Brush) ;
	SelectObject(hdc , Old_Pen) ;
}


/** TEXT""ɂo[OtiPUiKj
 * @fn     void text_Bar_graph( HDC hdc, int x, int y, int d) 
 * @param  hdc  : device context handle
 * @param  x    : `擪ʒuiX)
 * @param  y    : `擪ʒuiY)
 * @param  d    : OtliO`PTj
 *
 */
void text_Bar_graph( HDC hdc, int x, int y, int d) 
{
	int i;
	int x0;
	char t[] = "";
	int sz = strlen(t);

	x0 = x;
	SetTextColor(hdc, RGB(255, 0, 0));
	TextOut(hdc, x, y, "E", 1);
	x = x + 10 ;
	for (i = 0 ; i < 4 ; i++)
	{
		if ( i >= d ) SetTextColor(hdc, RGB(  0, 0, 0));
		TextOut(hdc, x+i*12, y, t, sz);
	}

	SetTextColor(hdc, RGB(255, 255, 0));
	for (i = 4 ; i < 8 ; i++)
	{
		if ( i >= d ) SetTextColor(hdc, RGB(  0, 0, 0));
		TextOut(hdc, x+i*12, y, t, sz);
	}

	SetTextColor(hdc, RGB(  0, 255, 0));
	for (i = 8 ; i < 16 ; i++)
	{
		if ( i >= d ) SetTextColor(hdc, RGB(  0, 0, 0));
		TextOut(hdc, x+i*12, y, t, sz);
	}

	SetTextColor(hdc, RGB(  0,255, 0));
	TextOut(hdc, x0+208, y, "F", 1);
}

/** o[Ot(Full rect)
 * @fn     void rect_Bar_graph( HDC hdc, int x, int y, int d)
 * @param  hdc  : device context handle
 * @param  x    : `擪ʒuiX)
 * @param  y    : `擪ʒuiY)
 * @param  d    : OtliO`PQVj
 *
 */
void rect_Bar_graph( HDC hdc, int x, int y, int d)
{
	RECT rect;
	int  Width =180 ;

	SetTextColor(hdc, RGB(255, 0, 0));
	TextOut(hdc, x, y, "E", 1);

	SetTextColor(hdc, RGB(  0,255, 0));
	TextOut(hdc, x+208, y, "F", 1);

	x = x + 18 ;
	y = y + 3 ;
	rect.top = y ;
	rect.left= x ;
	rect.bottom = y + 10 ;
	rect.right  = x + d ;
	FillRect(hdc ,&rect ,hBrush_G);
	rect.top = y ;
	rect.left= x + d ;
	rect.bottom = y + 10 ;
	rect.right  = x + Width ;
	FillRect(hdc ,&rect ,hBrush_R);
}


/** TEXT"-"ɂo[OtiPUiKj
 * @fn     void text_POS_Bar( HDC hdc, int x, int y, int d, char* nm) 
 * @param  hdc  : device context handle
 * @param  x    : `擪ʒuiX)
 * @param  y    : `擪ʒuiY)
 * @param  d    : OtliO`PTj
 * @param  nm   : `敶|C^
 *
 */
void text_POS_Bar( HDC hdc, int x, int y, int d, char* nm) 
{
	int wd = 8;	// o[Ot̕Ԋu
	int i;

	SetTextColor(hdc, RGB(255,255,  0));	// eLXgFiFj
	TextOut(hdc, x, y, nm++, 1);			// 񂩂ŏ̂P`
	x = x + wd +3 ;
	for (i = 0 ; i < 16 ; i++)
	{
		SetTextColor(hdc, RGB(255,255,255));
		if (( i == d )||( i == d+1 )) SetTextColor(hdc, RGB( 255, 0, 0));
		TextOut(hdc, x+i*wd, y, "-", 1);
	}

	SetTextColor(hdc, RGB( 255,255, 0));	// eLXgFiFj
	TextOut(hdc, x+i*wd+3, y, nm, 1);		// c̕̕`
}


/** rfI[h\
 * @fn     void Dsp_Vdo_Mode(HDC hdc,int sz, int x, int y )
 * @param  hdc  : device context handle
 * @param  sz   : rfI[h(0:QVGA 1:VGA)
 * @param  x    : `擪ʒuiX)
 * @param  y    : `擪ʒuiY)
 *
 */
void Dsp_Vdo_Mode(HDC hdc,int sz, int x, int y )
{
	char	Msg[64] ;

	switch(sz)
	{
		case 0:			//@QVGA mode
			wsprintf(Msg,"QVGA   ");
			break;
		case 1:			//@VGA mode
			wsprintf(Msg,"VGA    ");
			break;
		default:
			wsprintf(Msg,"?????  ");
			break;
	}
	TextOut(hdc, x, y, Msg, lstrlen(Msg));
}


