/** 
 * @file  IO_ctrl.h
 * @brief Device I/O Control header file
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#ifndef _IO_CTRL_H
#define _IO_CTRL_H
#include "def_dev.h"
#include "sub_module.h"

//		AxisiXeBbNj̓NX
class AXIS_ctrl:public IO_ctrl
{
public:
	AXIS_ctrl(void);
	virtual int	inp(void);
//	virtual int	inp_(void);
};

//		Buttoni{^j̓NX
class BUTT_ctrl:public IO_ctrl
{
public:
	BUTT_ctrl(void);
	virtual int	inp(void);
};

//		axis & POV(Point of View) device ̓NX
class POV_ctrl:public IO_ctrl
{
public:
	POV_ctrl(void);
	virtual int	inp(void);
};

//		DC motor o̓NX
class DCMT_ctrl:public IO_ctrl 
{
public:
	DCMT_ctrl(void);
	virtual void	out(void);
};

//		PWM output Device o̓NX
class PWM_ctrl:public IO_ctrl
{
public:
	PWM_ctrl(void);
	virtual void	out(void);
};

//		PWM output Device o̓NX
class PWM2_ctrl:public IO_ctrl
{
public:
	PWM2_ctrl(void);
	virtual void	out(void);
};

//		Digital Output o̓NX
class DO_ctrl:public IO_ctrl 
{
public:
	DO_ctrl(void);
	virtual void	set_min(int){;}
	virtual void	set_max(int){;}
	virtual void	out(void);
};

//		Video select port o̓NX
class VSEL_ctrl:public IO_ctrl 
{
public:
	VSEL_ctrl(void);
	virtual void	out(void);
};

//		VGA/QVGA select port o̓NX
class VGA_ctrl:public IO_ctrl 
{
public:
	VGA_ctrl(void);
	virtual void	set_min(int){;}
	virtual void	set_max(int){;}
	virtual void	out(void);
};

//		Action control mode ϐNX
class MODE_ctrl:public IO_ctrl 
{
public:
	MODE_ctrl(void);
	virtual void	out(void);
};

#endif /* ifndef _IO_CTRL_H */
