/** 
 * @file  IO_symbl.cpp
 * @brief I/O V{֐
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.01 : 2009/06/10 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include <string.h>
#include "IO_symbl.h"
#include "IO_ctrl.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉


/** entry device ID Device`|C^̎o
 * @fn     IO_ctrl* get_dev_ptr(int id)
 * @param  id  : entry device ID
 * @retval ==0 : error
 * @retval !=0 : device`|C^
 *
 */
IO_ctrl* get_dev_ptr(int id)
{
	if ((id < 0)||(id >= (int)max_dev_no)) return (0);
	return (dev_p[id]);	// device o^e[uo
}

/** input device ID Device`|C^̎o
 * @fn     IO_ctrl* get_in_dev_ptr(int id)
 * @param  id  : input device ID
 * @retval ==0 : error
 * @retval !=0 : device`|C^
 *
 */
IO_ctrl* get_in_dev_ptr(int id)
{
	IO_ctrl* p;
	int  i,j;
	int  n = -1;

	p = NULL;
	if ((id < 0)||( id > IN_DEV_MAX )) return (p);	// check ID (0 ` ő̓foCX)
	i = in_dev_p[id][0];		// ̓foCXo^e[u Entry device ID o
	if (i == -1)  return (p);	// o^ĂȂ ID̏ꍇ
	p = dev_p[i];				// Device`|C^̎o
	if ( p != NULL )  n = p->get_dev_n();
	if (( n != -1)&&( n < 4)) {	// action modẽfoCXH
		j = in_dev_p[id][act_mode];		// action mode ɑΉEntry device IDo
		if ( j != -1 ) p = dev_p[j];	// Device`|C^̎o
//		else p = NULL;					// error
		else p = dev_p[i];				// action mode ɓo^ĂȂꍇ
	}
	return (p);
}

/** output device ID Device`|C^̎o
 * @fn     IO_ctrl* get_out_dev_ptr(int id)
 * @param  id  : output device ID
 * @retval ==0 : error
 * @retval !=0 : device`|C^
 *
 */
IO_ctrl* get_out_dev_ptr(int id)
{
	IO_ctrl* p;
	int  i;

	p = NULL;
	if ((id < 0)||( id > OUT_DEV_MAX )) return (p);	// check ID (0 ` őo̓foCX)
	i = out_dev_p[id];			// o̓foCXo^e[u Entry device ID o
	if (i != -1)  p = dev_p[i];	// Device`|C^̎o
	return (p);
}

/** foCXDevice(entry all)ID̎o
 * @fn     int get_dev_id(char* name)
 * @param  name : device name(ex. "LX[1]")
 * @retval ==-1 : error
 * @retval > 0  : entry device ID
 *
 */
int get_dev_id(char* name)
{
	int i;
	int no;
	int n;
	char nm[32];
	char *p;

	no = -1;
	n  = -1;
	if ((strlen(name)< 1)||(strlen(name)> 31)) return(no);	// device name̕`FbN
	strcpy( nm, name );
	p = str_split( nm );	// Yi[ ]ň͂܂ꂽjo
	if ( p != NULL ) n = atoi( p );
	for ( i = 0 ; i < (int)max_dev_no ; i++ )	// o^foCXAfoCXT[`
	{
		if ( dev_p[i] != 0 ) {
			if (strcmp( nm , dev_p[i]->get_dev_nm()) == 0) {	// Y܂܂ȂfoCXŔr
				if ( dev_p[i]->get_dev_n() == n ) {
					no = i ;
					break;
				}
			}
		}
	}
	return (no);
}

/** foCX̎o
 * @fn     int get_dev_info(int no , DEF_DEV_t* info)
 * @param  no   : entry device ID
 * @param  info : foCXi[|C^
 * @retval ==-1 : error
 * @retval ==no : OK
 *
 */
int get_dev_info(int no , DEF_DEV_t* info)
{

	if ((no >= 0)&&(no < (int)max_dev_no)) {
		if ( dev_p[no] != 0 ) {
			memcpy( info, dev_p[no]->get_dev_info(), sizeof(DEF_DEV_t));
			return (no);
		}
	}
	return -1;
}

