/** 
 * @file  RS_com.cpp
 * @brief RS232ʐM Module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include  <windows.h>
#include  <stdio.h>
#include "system.h"
#include "UDP_com.h"
#include "sub_module.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉

COM_trace* tr = NULL ;

static HANDLE  hUDP_com ;
static DWORD   thrID_UDP_com ;
static w32udp* udp   = NULL;
static w32sio* rs232 = NULL;

static int UDP_com_f ;

static HANDLE  muMSG;     // mutex Message
static char	snd_msg[256] ; //= "UDP_SIO start\r\n";
static char	rcv_msg[256] ;
static int	rv_sz;
static char	rcv_buf[256];
static char	snd_buf[256];
static int	snd_cnt,rcv_cnt;
static char UDP_init_msg[256] = "UDPcom ERROR";


/** Lf[^EANZX Lock
 * @fn     void UDP_com_lock(void)
 *
 */
void UDP_com_lock(void)
{
	WaitForSingleObject( muMSG, INFINITE ) ;
}

/** Lf[^EANZX unLock
 * @fn     void UDP_com_unlock(void)
 *
 */
void UDP_com_unlock(void)
{
	ReleaseMutex( muMSG ) ;
}

/** UDP comPort ʐM^XN
 * @fn     void UDP_com(void)
 *
 */
void UDP_com(void)
{
	static DWORD TM_now,TM_prv,TM_itv;
	int n;
	int atr_b ;
	static int sd_sz;

	muMSG = CreateMutex(0, FALSE, 0);
	rcv_cnt = 0;
	rv_sz   = 0;
	TM_now   = 0;
	TM_prv   = 0;
	sd_sz    = 0;
	snd_cnt  = 0;

	while(UDP_com_f){
	// ----- f[^ -------
		UDP_com_lock() ;

		if(rcv_cnt > 0) {
			n = rs232->send(rcv_buf,rcv_cnt);
			rcv_cnt = 0;
		}
		if ((snd_cnt > 0)&&(sd_sz == 0))
		{
			memcpy( snd_buf,snd_msg,snd_cnt );
			sd_sz   = snd_cnt;
			snd_cnt = 0;
		}
		if (sd_sz == 0)
		{
			n = rs232->recv( snd_buf, 32);
			if ( n > 0 ) sd_sz = n;
		}
		UDP_com_unlock() ;

		if (sd_sz > 0) {
			n = udp->send(snd_buf,sd_sz);

			TM_now = timeGetTime();
			if ( TM_prv ) TM_itv = (TM_now - TM_prv) ;
			else TM_itv = 0;
			atr_b = Limit( TM_itv/2, 0, 250 );
			int i;
			for ( i = 0 ; i < n ; i++ ) {
				tr->put_data( (unsigned char)atr_b ,(unsigned char)(snd_buf[i]&0xff));
				atr_b = 0;
			}
			TM_prv = TM_now ;
			sd_sz = 0;
		}

		n = udp->recv_rt(&rcv_buf, sizeof(rcv_buf), 5*1000);

		if (n > 0) 
		{
			atr_b = 254;
			int i;
			for ( i = 0 ; i < n ; i++ ) {
				tr->put_data( (unsigned char)atr_b ,(unsigned char)(rcv_buf[i]&0xff));
				atr_b = 254;
			}
			rcv_cnt = n ;
		}

	}
	CloseHandle( muMSG ) ;
}

/** UDP comPort ʐM 
 * @fn     int UDP_com_init(void)
 * @retval == 0  : OK
 * @retval == -1 : error
 *
 */
int UDP_com_init(void)
{
	FILE *stream;
	char   rd_msg[256];
	int   port_no;
	char  host_adr[32];
	char  com_port[8];
	int   sio_speed;
	char*  res;

	snd_msg[0] = 0;
	int	err = -1;

	stream = fopen( "UDP_set.txt", "r" );
	if( stream != NULL )
	{
		res = fgets(rd_msg,255,stream);
		if (res != NULL) {
			sscanf( rd_msg, "%s %d %s %d", host_adr , &port_no, com_port, &sio_speed);
			err = 0;
		}
		fclose( stream );
	}
	if (err < 0) return (-1);

	udp = new w32udp("UDP_C");
	if (udp == NULL) return (-1);
	err = udp->open(host_adr, port_no, 50) ;
	if (err < 0) return (-1);

	rs232 = new w32sio(com_port);
	if (rs232 == NULL) return (-1);
	err = rs232->open(sio_speed, X_ON, -1);
	if (err < 0) return (-1);

	sprintf(UDP_init_msg, "UDPcom OK <%s><%d><%s><%d>",host_adr, port_no,com_port,sio_speed);
	tr = new(COM_trace);		// Create COM Trace class
	tr->init( 1024 );		// Create Trace Buffer

	UDP_com_f = 1 ;
	hUDP_com = CreateThread(0,0,(LPTHREAD_START_ROUTINE)UDP_com,0,0,&thrID_UDP_com);
	return (0);
}

/** UDP comPort ʐM igdlj
 * @fn     int UDP_com_init_ex(char* host_adr, int port_no, char* com_port, int sio_speed)
 * @param  host_adr  : UDPʐMTPIP IP address
 * @param  port_no   : UDPʐMport no
 * @param  com_port  : comPort
 * @param  sio_speed : RS232ʐM̒ʐMx(bps)
 * @retval == 0      : OK
 * @retval == -1     : error
 *
 */
int UDP_com_init_ex(char* host_adr, int port_no, char* com_port, int sio_speed)
{

	snd_msg[0] = 0;
	int	err = -1;

	udp = new w32udp("UDP_C");
	if (udp == NULL) return (-1);
	err = udp->open(host_adr, port_no, 50) ;
	if (err < 0) return (-1);

	rs232 = new w32sio(com_port);
	if (rs232 == NULL) return (-1);
	err = rs232->open(sio_speed, X_ON, -1);
	if (err < 0) return (-1);

	sprintf(UDP_init_msg, "UDPcom OK <%s><%d><%s><%d>",host_adr, port_no,com_port,sio_speed);
	tr = new(COM_trace);		// Create COM Trace class
	tr->init( 512 );		// Create Trace Buffer

	UDP_com_f = 1 ;
	hUDP_com = CreateThread(0,0,(LPTHREAD_START_ROUTINE)UDP_com,0,0,&thrID_UDP_com);
	return (0);
}

/** UDP comPort ʐM I
 * @fn     int	UDP_com_end(void)
 * @retval == 0  : OK
 *
 */
int	UDP_com_end(void)
{
	UDP_com_f = 0 ;
	Sleep(100);
	if (tr) delete (tr);
	if (rs232) {
		rs232->close();
		delete (rs232);
		rs232 = NULL;
	}
	if (udp) {
		udp->close();
		delete (udp);
		udp   = NULL;
	}

	return (0);
}

/** UDPMf[^ Zbg֐
 * @fn     int UDP_set_sddata( void* sd_buf, int sd_sz )
 * @param  sd_buf : Mf[^E|C^
 * @param  sd_sz  : Mf[^ETCY
 * @retval        : Mf[^
 *
 */
int UDP_set_sddata( void* sd_buf, int sd_sz )
{
	int ans ;
	char* sd_data;

	ans = 0;
	sd_data = (char*)sd_buf;
	if (sd_sz > 32) sd_sz = 32;
	UDP_com_lock() ;

	if((snd_cnt == NULL)&&(sd_sz > 0)) {
		memcpy(snd_msg,sd_data,sd_sz);
		snd_cnt = sd_sz;
		ans     = sd_sz;
	}

	UDP_com_unlock() ;
	return (ans);
}

/** UDPMf[^ Zbg֐
 * @fn     int UDP_get_rvdata( void* rv_buf )
 * @param  rv_buf : Mf[^obt@E|C^
 * @retval        : Mf[^
 *
 */
int UDP_get_rvdata( void* rv_buf )
{
	int ans ;
	char* rcv_data;

	ans = 0;
	rcv_data = (char*)rv_buf;
	UDP_com_lock() ;

	if((rcv_data != NULL)&&(rv_sz > 0)) {
		memcpy(rcv_data,rcv_msg,rv_sz);
		ans   = rv_sz;
		rv_sz = 0;
	}

	UDP_com_unlock() ;
	return (ans);
}

/** UDP comPort ʐM bZ[Wo֐
 * @fn     char* UDP_get_info(void)
 * @retval   : bZ[W|C^
 *
 */
char* UDP_get_info(void)
{
	return (UDP_init_msg);
}
