/** 
 * @file  WinMain.cpp
 * @brief Windows Main Module <APP:TPIP_RRC.exe>
 *
 * @author Katayama
 * @date 2009-01-26
 * @date 2014-03-01 gpCu𐧌{[hΉłɍXV(TPJT) hoshino
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.00 : 2009/04/01 katayama (for TPIP2)
 * @version 2.01 : 2009/06/09 katayama (for TPIP2)
 * @version 2.02 : 2010/03/15 katayama
 * @version 3.00 : 2013/07/17 hoshino  (for TPIP3) 
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3) 
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

// ver 2.02 : TPIP2 RRC ver 2.02(2.0.2.1) `֎~Ԃ̕Aǉ

#define WINVER 0x0500
#include <windows.h>
#include <stdio.h>
#include "system.h"
#include "def_dev.h"
#include "Time_meas.h"
#include "Dsp_Input.h"
#include "dev_ctrl.h"
#include "com_sub.h"
#include "Dsp_proc.h"
#include "Dsp_sub.h"
#include "Dsp_RRC.h"
#include "UDP_com.h"
#include "IO_symbl.h"
#include "sub_module.h"

DWORD TM_dsp = 0;	// `掞
int dsp_mode = 0;
static void* jpeg_data;
static int jpeg_size;
static HWND  hwnd ;	
static int cam_no =0;

static int cam_count =0;
int m_xpos;			// Mouse position x
int m_ypos;			// Mouse position x
int n_count = 0;
int forward = 0 ;	// Forward JPEG file

static char Msg[256];

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM) ;

/** Windows Main routine
 * @fn     int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,PSTR szCmdLine, int iCmdShow)
 * @param  hInstance     : AvP[ṼCX^Xnh
 * @param  hPrevInstance : AvP[V̑ÕCX^X̃nh(NULL)
 * @param  szCmdLine     : R}hCi[ꂽ̃|C^
 * @param  iCmdShow      : EBhEǂ̂悤ɕ\邩̎w
 * @retval == 0          : error
 * @retval IR[h    : Windows̏IbZ[WŏI
 *
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   PSTR szCmdLine, int iCmdShow)
{
	static TCHAR szAppName[] = TEXT ("TPIP RRC3") ;		// [Ver 2.00]
	HWND         hwnd ;
	MSG          msg ;
	WNDCLASS     wndclass ;
	wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
	wndclass.lpfnWndProc   = WndProc ;
	wndclass.cbClsExtra    = 0 ;
	wndclass.cbWndExtra    = 0 ;
	wndclass.hInstance     = hInstance ;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION) ;
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName  = NULL ;
	wndclass.lpszClassName = szAppName ;


	if (!RegisterClass (&wndclass)) {
			MessageBox (NULL, TEXT ("This program requires Windows NT!"),
						szAppName, MB_ICONERROR);
			return 0 ;
	}

	int ans;

#ifdef _TEST__
	TM_Init();			// Inital Time(debug)
#endif
	Init_Dsp();			// \\[X@
	dev_init();			// foCXo^e[ȕ
	xchg_init();		// o̓f[^e[ȕ
	dsp_entry_init();	// \o^̏
	com_req_mode = 3;	// comm. Request mode : JPEG + SIO
	ans = dev_config("config.csv");	// RtBO[VEt@C ݒ

	hwnd = CreateWindow (szAppName,					// window class name
						 TEXT("TPIP3 RRC 3.01"),	// window caption	// [Ver 3.00]
						 WS_SYSMENU,				// window style
						 0,							// initial x position
						 0,							// initial y position
						 1024,// 1024,						// initial x size
						 744,// 768-24,					// initial y size
						 NULL,						// parent window handle
						 NULL,						// window menu handle
						 hInstance,					// program instance handle
						 NULL);						// creation parameters

	ans = TPGM_create(hwnd,vga,NULL);				// T[tFX(1:VGA)
	TPJT_init_ex(ip_address, hwnd, com_req_mode);	// A^C`̏

	ShowWindow (hwnd, iCmdShow);
	UpdateWindow (hwnd);

if (com_req_mode & 0x2) TPGC_init(hInstance,hwnd);	// Joysticck 
if (com_req_mode == 5) {	// remote SIO @\ ON ̏ꍇ
	//TPJT_set_rSIO_para(udp_port, sio_speed);
	udp_sio_f = UDP_com_init_ex( ip_address, udp_port, com_port, sio_speed );
}

	while (GetMessage (&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

/** Windows I
 * @fn     void WM_Destroy()
 *
 */
void WM_Destroy()
{
	xchg_relese();
	dev_relese();
	dsp_relese();
	Delete_Dsp();
	TPJT_close();		// close `
	//if (com_req_mode & 0x2) TPGC_close();
	TPGM_delete();	// T[tFXj
#ifdef _TEST__
	TM_close();
#endif
}

/** ^C}[
 * @fn     void WM_Timer(HWND hWnd, WPARAM wParam)
 * @param  hWnd   : windows handle
 * @param  wParam : Timer ID
 *
 */
void WM_Timer(HWND hWnd, WPARAM wParam)
{
	static int dd ;
	static DWORD ms500 = 0 ;
	static int s_m_xpos = 0;
	static int c_down;

	if (com_req_mode & 0x2) {

		if (TPGC_get( &ps2 )) {
			all_dev_in();
			xchg_act();
		}
		
		all_dev_out();
		
	}

#ifdef _TEST__
	_tm3->End();	// vend
	_tm3->Start();	// vstart
#endif
	if ((timeGetTime() - TM_dsp) > 100 ) {	// `Ԋu100msȏɂȂꍇ
		InvalidateRect(hWnd, NULL, FALSE);	// ʍXV
	}

	if (dd != 0) {	// 100ms
	// _ŕ\pϐ@XV
		if ( ms500 >= 5) {	// 500ms
			blink_flg = (blink_flg ^ 0x01);
			ms500 = 0 ;
		}
		ms500++;
		dd = 0 ;
	}
	else dd = 1 ;

	if (s_m_xpos != m_xpos) { s_m_xpos = m_xpos;  c_down = 30; }
	else if (c_down >0 ) { 
		c_down--;
		if (c_down == 0) {SetCursor( NULL ); n_count++ ; }
	}

}

/** L[͏
 * @fn     void WM_KeyDown(HWND hWnd, UINT wParam)
 * @param  hWnd   : windows handle
 * @param  wParam : zkey code
 *
 */
void WM_KeyDown(HWND hWnd, UINT wParam)
{
	IO_ctrl* p;

	switch(wParam){
		
		case 'X':	// Change QVGA / VGA
			p = get_dev_ptr(get_dev_id("VGA"));
			if ( p == 0 ) return;
			p->set_vol((p->get_vol()+1)%2);
			return ;

		case VK_LEFT:
			p = get_dev_ptr(get_dev_id("VSEL"));
			if ( p == 0 ) return;
			p->addc(-1);
			return ;
		case VK_RIGHT:
			p = get_dev_ptr(get_dev_id("VSEL"));
			if ( p == 0 ) return;
			p->addc(1);
			return ;

		case VK_UP:
			set_JPEG_speed(get_JPEG_speed() + 100);
			return;
		case VK_DOWN:
			set_JPEG_speed(get_JPEG_speed() - 100);
			return;

		case 'Z':
			TM_Init();
			return;
		case VK_ESCAPE:
		case VK_F12:
			DestroyWindow(hWnd);		// EChE
			return;
	}
}

/** window `揈
 * @fn     void WM_Paint(HWND hWnd)
 * @param  hWnd   : windows handle
 *
 */
void WM_Paint(HWND hWnd)
{
	HDC hdc ;
	static HDC hdc_old = (HDC)-1;
	int ans;
	static int pJPEG;
	static int iDBG_mode_P ;
	static int s_vga = 0;
	static int sz = 0 ;
	int x,y;
	HFONT  hFontOld;

#ifdef _TEST__
	_tm0->Start();	// `掞Ԍvstart
#endif

// JPEG	f[^̎o
	jpeg_data = TPJT_get_jpeg_file(0, 0, &jpeg_size);
	if ((jpeg_data)&&(jpeg_size > 0)) {
#ifdef _TEST__
		_tm2->Start();	// JPEG decodeԌvstart
#endif
		ans = TPGM_decode(jpeg_data, jpeg_size);
#ifdef _TEST__
		_tm2->End();	// JPEG decodeԌvend
		_tm1->End();	// JPEG XVԌvend
		_tm1->Start();	// JPEG XVԌvstart
#endif
	}
	TPJT_free_jpeg_file();	// JPEG file 

// VGA or QVGA ̐ؑւ肪̏
	if ( s_vga != vga ) {
		TPGM_delete();					// T[tFXj
		TPGM_create(hWnd, vga, NULL);		// T[tFXĐ
		s_vga = vga;
	}

// `֎~Ԃ̕A`FbN@@ver 2.02
	hdc = TPGM_getDC();
	if ((hdc_old == NULL)&&(hdc != NULL)) {
		TPGM_releaseDC();				// device context ̉
		TPGM_delete();					// T[tFXj
		TPGM_create(hWnd, vga, NULL);	// T[tFXĐ
		hdc = TPGM_getDC();				// device context ̎擾
	}
	hdc_old = hdc;
	TPGM_releaseDC();					// device context ̉

// 摜̓]i@@Ɖʁj
	TPGM_copy(192 ,100);

// ȊỎʍ쐬
	hdc = TPGM_getDC();

	x = 0;	y = 0;
	SetBkColor(hdc, RGB(0, 0, 0));			// wiFw

	SetTextColor(hdc, RGB( 0, 255, 255));	// FwiVAj
	Dsp_Com_Mode(hdc);						// ʐMԁ@\

	hFontOld = (HFONT)SelectObject( hdc, Font_set(0));	// \tHgw
	SetTextColor(hdc, RGB( 255, 210, 210));	// FwisNj
	Dsp_camera_no(hdc, 50, 100);			// JNO.@\
	Dsp_Vdo_Mode(hdc,vga,80,120);			// Video mode \
	
	if (com_req_mode & 0x2) // ʐML
			Dsp_Batt(hdc,  750, 30);	// obe[c

	SelectObject( hdc, Font_set(2));	// \tHgw
	if (com_req_mode & 0x2) {
		SetTextColor(hdc, RGB( 255, 150, 0));	// FwiIWFj
		Dsp_Joy( hdc, 10, 600 );	// Joystick & control output(MT/PWM/DO) \
	}
	if (com_req_mode == 5) {
		SetTextColor(hdc, RGB( 255, 255,255));	// Fwij
		Dsp_SIO_mon(hdc, 40, 600 );			//RS232ʐM̃j^\
	}
	if (com_req_mode & 0x2) {
		SetTextColor(hdc, RGB( 200, 200, 200));	// Fwi邢DFj
		Dsp_AI_bar( hdc );			// ͒l\io[OtAVZO\j
	}
#ifdef _TEST__
	SetTextColor(hdc, RGB( 0, 200, 200));	// FwiÂVAj
	x = 840 ; y = 60;
	_tm0->dsp_time( hdc, x, y);	y = y+ 40;	// Drow time
	_tm1->dsp_time( hdc, x, y); y = y+ 40;	// Refresh time
	_tm2->dsp_time( hdc, x, y); y = y+ 40;	// Jpeg Expand time
	_tm3->dsp_time( hdc, x, y); y = y+ 40;	// cycle time
#endif

	SelectObject( hdc, hFontOld);	// \tHgɖ߂
	TPGM_releaseDC();	// device context ̉
	TPGM_screen();		// \ʂ֓]
#ifdef _TEST__
	_tm0->End();		// `掞Ԍvend
#endif
}


/** Windows Main routine
 * @fn     LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
 * @param  hwnd     : windows handle
 * @param  message  : window message
 * @param  wParam   : window parameter 1
 * @param  lParam   : window parameter 2
 * @retval          : bZ[W̌
 *
 */
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message) {
	case WM_CREATE:		// Window
		SetTimer(hwnd, 1, 50, NULL);
		return 0 ;

	case WM_TIMER:		// Timer Event
		WM_Timer(hwnd, wParam);
		ref_ctrl_dt();				//  / ZT[@XV
		return 0 ;

	case WM_MOUSEMOVE:	// }EXJ[\ړ
		m_xpos = LOWORD(lParam);	// mouse position(x)
		m_ypos = HIWORD(lParam);	// mouse position(y)
		return 0;

	case WM_KEYDOWN:	// L[
		WM_KeyDown(hwnd, wParam);
		return 0 ;

	case WM_PAINT:		// ` Event 
		ValidateRect(hwnd,NULL);	// CALLȂWM_PAINTbZ[WoɂȂB
		WM_Paint(hwnd);
		TM_dsp  = timeGetTime();	// save `掞
		return 0;

	case WM_DESTROY:	// Window I
		WM_Destroy();
		PostQuitMessage (0);
		return 0 ;
	}
	return DefWindowProc (hwnd, message, wParam, lParam) ;
}


