/** 
 * @file  def_dev.cpp
 * @brief foCXyыʕϐ̒` module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.01 : 2009/06/10 katayama (for TPIP2)
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include "def_dev.h"

/**
 *  Rg[͒`@ftHgEe[u
 *  ips2 Gamepadj
 */
DEF_DEV_t in_dev_default[] = {
	"LX", -1, AXIS_,0,		// Axis[0]
	"LY", -1, AXIS_,1,		// Axis[1]
	"RX", -1, AXIS_,2,		// Axis[2]
	"RY", -1, AXIS_,5,		// Axis[5]
	"RU", -1, BUTT_,0,		// Button[0]
	"RR", -1, BUTT_,1,		// Button[1]
	"RD", -1, BUTT_,2,		// Button[2]
	"RL", -1, BUTT_,3,		// Button[3]
	"L2", -1, BUTT_,4,		// Button[4]
	"R2", -1, BUTT_,5,		// Button[5]
	"L1", -1, BUTT_,6,		// Button[6]
	"R1", -1, BUTT_,7,		// Button[7]
	"ST", -1, BUTT_,8,		// Button[8]
	"SE", -1, BUTT_,9,		// Button[9]
	"LB", -1, BUTT_,10,		// Button[10]
	"RB", -1, BUTT_,11,		// Button[11]
	"LU", -1, POV_ ,0,		// Pov_bit[0]
	"LR", -1, POV_ ,1,		// Pov_bit[1]
	"LD", -1, POV_ ,2,		// Pov_bit[2]
	"LL", -1, POV_ ,3,		// Pov_bit[3]
	""  , -1, -1   ,-1	// End Table
};
size_t max_in_dev_default_no = (sizeof(in_dev_default)/sizeof(in_dev_default[0]));


//
//   V{́@@IDԍ@ϊ֐
//   ́
//
/**
 *  foCX@o^e[u
 *  iV{́@@IDԍj
 */
DEF_DEV_t  in_dev_name[IN_DEV_MAX] ;	// ̓foCX table
size_t in_dev_name_cnt = 0;

DEF_DEV_t  out_dev_name[] = {			// o̓foCX table
	"PWM1", -1 , PWM_ ,0,	// PWM[0]
	"PWM2", -1 , PWM_ ,1,	// PMW[1]
	"PWM3", -1 , PWM_ ,2,	// PMW[2]
	"PWM4", -1 , PWM_ ,3,	// PMW[3]
	"PWM5", -1 , PWM2_ ,0,	  // PMW2[0]
	"PWM6", -1 , PWM2_ ,1,	  // PMW2[1]
	"PWM7", -1 , PWM2_ ,2,	  // PMW2[2]
	"PWM8", -1 , PWM2_ ,3,	  // PMW2[3]
	"PWM9", -1 , PWM2_ ,4,	  // PMW2[4]
	"PWM10", -1 , PWM2_ ,5,	  // PMW2[5]
	"PWM11", -1 , PWM2_ ,6,   // PMW2[6]
	"PWM12", -1 , PWM2_ ,7,   // PMW2[7]
	"PWM13", -1 , PWM2_ ,8,   // PMW2[8]
	"PWM14", -1 , PWM2_ ,9,   // PMW2[9]
	"PWM15", -1 , PWM2_ ,10,  // PMW2[10]
	"PWM16", -1 , PWM2_ ,11,  // PMW2[11]
	"PWM17", -1 , PWM2_ ,12,  // PMW2[12]
	"PWM18", -1 , PWM2_ ,13,  // PMW2[13]
	"PWM19", -1 , PWM2_ ,14,  // PMW2[14]
	"PWM20", -1 , PWM2_ ,15,  // PMW2[15]
	"MT1" , -1 , DCMT_,0,	// DC motor
	"VSEL", -1 , VSEL_,0,	// Video Select
	"VGA" , -1 , VGA_ ,0,	// VGA
	"MODE", -1 , MODE_,0,	// action mode
	"DO1" , -1 , DO_  ,0,	// DO bit 0
	"DO2" , -1 , DO_  ,1,	// DO bit 1
	"DO3" , -1 , DO_  ,2,	// DO bit 2
	"DO4" , -1 , DO_  ,3,	// DO bit 3
	"DO5" , -1 , DO_  ,4,	// DO bit 4
	"DO6" , -1 , DO_  ,5,	// DO bit 5
	"DO7" , -1 , DO_  ,6,	// DO bit 6
	"DO8" , -1 , DO_  ,7,	// DO bit 7
	"DO9" , -1 , DO_  ,8,	// DO bit 8
	""    , -1 , -1   ,-1	// End Table
};
#define OUT_DEV_NAME_NO (sizeof(out_dev_name)/sizeof(out_dev_name[0]))	// o̓foCX o^

size_t out_dev_name_cnt = OUT_DEV_NAME_NO ;	// o̓foCX o^
size_t max_dev_no = 0;			// foCXo^
size_t max_dev_p  = DEV_P_MAX;	// foCXo^ ő呍

char in_dev_p [IN_DEV_MAX][4];	// ̓foCXID table
char out_dev_p[OUT_DEV_MAX];	// o̓foCXID table
IO_ctrl* dev_p[DEV_P_MAX];		// foCXo^ table

int XCHG_max_cnt = 0;			// o̓f[^table o^
XCHG_ctrl* xchg_p[MAX_XCHG_NO];	// o̓f[^table

#define MAX_DSP_NO 14
int DSP_ent_cnt = 0;			// ͒l\ o^
IO_dsp* dsp_dev_p[MAX_DSP_NO];	// ͒l\ o^table
size_t max_dsp_no = MAX_DSP_NO;

/**
 *  ʐM֘A@ϐ
 */
char ip_address[16]   = "192.168.0.200";
int  JPEG_speed[2]    = {4000, 5000};	// 摬xݒl@[QVGA:4000 / VGA:5000]
char com_port[8];				// RS232 com port name
int  sio_speed;					// RS232 ʐMx
int  udp_port;					// remoteSIO UDP port no
int  udp_sio_f;					// remoteSIO gptO
int  com_req_mode;				// ʐM[h

/**
 *  Game controller ϐ
 */
struct GC_STRUCT ps2 ;

unsigned char MT;		// DC motor
unsigned char PWM[4];	// PWM 4ch
unsigned char PWM2[16];	// PWM 4ch
unsigned short d_out;	// digital output

int act_mode = 0;	//  {^EANV[h@ϐ

					//@\Rg[@ϐ
int vga = 0;		// 0:QVGA 1:VGA
int camera_no = 0;	// JNo (0 - 2)
int blink_flg;		// _ŕ\p@ϐ( 0 - 1 )

int Batt_i ;
int Batt_v ;
int Batt_min = 65;	//   0% d<defau : 6.5V>
int Batt_max = 75;	// 100% d<defau : 7.5V>
int AI_ch[8];
int PI_ch[4];

int ctrl_no = 0;


