/** 
 * @file  def_dev.h
 * @brief foCXyыʕϐ̒` Header file
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#ifndef __DEF_DEV_H__
#define __DEF_DEV_H__

#include <windows.h>
#include "system.h"


/** [^Cv`]
 *  foCX̍\(DEF_DEV_t)
 */
typedef struct DEF_DEV_STR {
	char name[12];	// device name
	char n;			// reserved
	char dv_type;	// device type
	short ch_no;	// channel no (0 - )
} DEF_DEV_t;

/** [^Cv`]
 *  foCX̏ԏ̍\(VIEW_t)
 */
typedef struct VIEW_STR {
	DEF_DEV_t dev_if;
	int		mask;	// Button mask bit
	int		min;	// Minimum volume
	int		max;	// Maximum volume
	int		vol;	// volume is now
	int		dzone;	// Dead zone
	int		f_min;	// Full minimum
	int		f_max;	// Full maximum
	int		mode;	// Device status < 0:idle 1:idle->up(down) 2:up(down) 3:up(down)->idle >
} VIEW_t;


/** [NX`]
 *   o̓foCXENX(IO_ctrl)
 */
class IO_ctrl {
public:
	IO_ctrl(void){;}
	void init(int dev_id, DEF_DEV_t* dev_nm);
	int  get_pos(void);
	virtual void	set_dzone(int);
	virtual int 	get_dev_n(void)			{ return (dev_if.n); }
	virtual void	set_dev_n(int);
	virtual int		get_dv_type(void)		{ return (dev_if.dv_type); }
	virtual void	set_min(int);
	virtual void	set_max(int);
	virtual int		get_min(void)			{ return min; }
	virtual int		get_max(void)			{ return max; }
	virtual int		set_vol(int);
	virtual int		get_vol(void)			{ return vol; }
	virtual char*	get_dev_nm(void)		{ return (&dev_if.name[0]); }
	virtual DEF_DEV_t* get_dev_info(void)	{ return (&dev_if); }
	virtual int		add(int);
	virtual int		addc(int);
	virtual int		inp(void)				{return 0;}
	virtual int		get_mode(void)			{return mode;}
	virtual void	out(void)				{;}
	void	view(VIEW_t* v);
protected:
	DEF_DEV_t dev_if;
	int		mask;	// Button mask bit
	int		min;	// Minimum volume
	int		max;	// Maximum volume
	int		vol;	// Volume is now
	int		dzone;	// Dead zone
	int		f_min;	// Full minimum
	int		f_max;	// Full maximum
	int		mode;	// Device status
};

/** [NX`]
 *   o̓f[^NX(XCHG_ctrl)
 */
class XCHG_ctrl {
public:
	XCHG_ctrl(void);
	void init(IO_ctrl* in_dev_p,IO_ctrl* out_dev_p, int vol, int init_v, int a_type );
	IO_ctrl* in_dev;	// Input device class
	IO_ctrl* out_dev;	// Output device class
	int		coeff;		// Coefficient
	int		init_vol;	// inital volume
	int		type;		// device type
	int		fade;		// fade mode
};

/** [NX`]
 *   o͏ \NX(IO_dsp)
 */
class IO_dsp {
public:
	IO_dsp(void);
	int		init(int ch, char* nm);
	void	set_pos(int x,int y, int w, int h);
	void	set_minmax(int min_, int max_);
	void	set_pi_para(int pcnt, int dia);
	int		get_vol(void);
	int		dsp_mode;		// 0:BarGraph 1:7seg
	int		type;			// 0:AI       1:PI
	void	dsp_Bar_graph( HDC hdc );
	void	dsp_7seg( HDC hdc );
protected:
	int		ch_no;
	HBRUSH	hBrush;
	char	io_name[8];
	int		xs;
	int		ys;
	int		ys_t;
	int		xe;
	int		ye;
	int		wide;
	int		height;
	int		min;
	int		max;
	int		p_cnt;	// P]pX
	int		dia;	// ^Ca(mm)
	float	k;		// vZW
};


//
//  Define Device Type code
//
// - Input device -
#define AXIS_	0	// axis device
#define BUTT_	1	// button device
#define POV_	2	// axis & POV(Point of View) device
// - Output device -
#define DCMT_	10	// DC motor
#define PWM_	11	// PWM device
#define DO_ 	12	// Digital Output device
#define VSEL_	13	// Video selete port
#define VGA_	14	// Video mode (VGA/QVGA) select port
#define PWM2_	15	// PWM device
// - control Variable -
#define MODE_	20	// Action control mode

#define AXIS_TOP_POS  0
#define AXIS_MAX 8

#define BUTT_TOP_POS  AXIS_TOP_POS + AXIS_MAX
#define BUTT_MAX 32

#define POV_TOP_POS   BUTT_TOP_POS + BUTT_MAX
#define POV_MAX  4*4

//  Output device
#define PWM_TOP_POS   0
#define PWM2_TOP_POS   4
#define PWM_MAX  20

#define OTHER_TOP_POS DCMT_TOP_POS
#define DCMT_TOP_POS  PWM_TOP_POS  + PWM_MAX
#define DCMT_MAX  1

#define VSEL_TOP_POS  DCMT_TOP_POS   + DCMT_MAX
#define VSEL_MAX  1

#define VGA_TOP_POS   VSEL_TOP_POS + VSEL_MAX
#define VGA_MAX  1

#define MODE_TOP_POS  VGA_TOP_POS  + VGA_MAX
#define MODE_MAX  1

#define DO_TOP_POS    MODE_TOP_POS + MODE_MAX
#define DO_MAX  9

#define OTHER_MAX  DCMT_MAX + VSEL_MAX + VGA_MAX + DO_MAX
#define TABLE_END 1

#define IN_DEV_MAX   (AXIS_MAX + BUTT_MAX   + POV_MAX   + TABLE_END)
#define OUT_DEV_MAX  (PWM_MAX  + OTHER_MAX  + TABLE_END)
#define DEV_P_MAX    ((IN_DEV_MAX * 4) + OUT_DEV_MAX)

extern DEF_DEV_t  in_dev_default[];		// ͒` defalt table
extern size_t max_in_dev_default_no;	//  default table count
extern DEF_DEV_t  in_dev_name[];		// ͒` table
extern DEF_DEV_t  out_dev_name[];		// o͒` table
extern size_t in_dev_name_cnt;			// ͒` table counter
extern size_t out_dev_name_cnt;			// o͒` table counter

extern char in_dev_p[][4];				// ͏p device table
extern char out_dev_p[];				// o͏p device table
extern size_t max_dev_no;				// All device entory table max count
extern IO_ctrl* dev_p[];				// All device entory table

extern int XCHG_max_cnt;
#define MAX_XCHG_NO 64
extern XCHG_ctrl* xchg_p[];

extern int DSP_ent_cnt;
extern size_t max_dsp_no ;
extern IO_dsp* dsp_dev_p[];		// AiO\p table


extern char ip_address[];
extern char m_cast_addr[];		// multi cast IP address
extern char m_cast_ifaddr[];	// multi cast interface address
extern int  JPEG_speed[];		// 摬xݒl
extern char com_port[];
extern int  sio_speed;
extern int  udp_port;
extern int  udp_sio_f;
extern int  com_req_mode;	// Bit0:JPEG Bit1:SIO Bit2:TCP-SIO app
extern struct GC_STRUCT ps2;

extern unsigned char MT;
extern unsigned char PWM[];
extern unsigned char PWM2[];
extern unsigned short d_out;

extern int act_mode;	// ANV[hϐ

extern int vga;				// 0:QVGA  1:VGA
extern int camera_no;		// JNo (0 - 2)
extern int blink_flg;		// _ŕ\p@ϐ( 0 - 1 )

extern int Batt_i ;
extern int Batt_v ;
extern int Batt_min ;
extern int Batt_max ;
extern int AI_ch[];
extern int PI_ch[];

#endif /* ifndef __DEF_DEV_H__ */