/** 
 * @file  dev_ctrl.cpp
 * @brief foCXERg[ module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.00 : 2009/04/01 katayama (for TPIP2)
 * @version 2.01 : 2009/06/09 katayama (for TPIP2)
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include "def_dev.h"
#include "IO_symbl.h"
#include "IO_ctrl.h"
#include "Dsp_RRC.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉


FILE *err_log;
char *err_log_name = "err_log.txt";
static char delimter[] = ",\n";		// fb~^[Zbg

/** IP address ݒ֐
 * @fn     void set_ip_address( char* ip )
 * @param  ip : IP address |C^
 *
 */
static void set_ip_address( char* ip )
{
	strcpy( ip_address , ip );
}

/** ϐ ID o֐
 * ϐo^e[uAΉĂϐIDo͂B
 * @fn     int get_var_id( char* var_nm)
 * @param  var_nm : ϐ |C^
 * @retval == -1  : ΉR}hȂ
 * @retval >= 0   : ΉR}h
 *
 */
static char def_var_nm [][8] = { "IP","REQ","USER","BATT","" };	// ϐo^e[u
static int get_var_id( char* var_nm)
{
	int  i;
	int  ans;

	i = 0;
	ans = -1;
	while ( strlen(&def_var_nm[i][0]) != 0 )
	{
		if (strcmp(&def_var_nm[i][0],var_nm)== 0) {
			ans = i;
			break;
		}
		i++;
	}
	return(ans);
}

/** ϐ ` ֐
 * @fn     int set_in_var( char* msg)
 * @param  var_nm : R}h |C^
 * @retval == -1  : ΉR}hȂ
 * @retval >= 0   : ΉR}h
 *
 */
static int set_in_var( char* msg)
{
	char* token;
	char var_nm[16];
	int  id;
	int  num;
	int  p1,p2;
//	int  p1,p2,p3;			// [Ver 2.00]
//	char com_port_[8];		// [Ver 2.00]
	int ans = 0;

	token = strtok( msg , delimter);
	if (token != NULL) sscanf(token,"%8s",var_nm);
	id = get_var_id( var_nm );
	switch (id) {
	case 0:  // $IP
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,".0123456789 \t") == NULL))  set_ip_address(token);
		else ans = 2;
		break;
	
/*[Ver 2.00]
	case 1:  // $REQ:comm request mode
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,"0123456789 \t") == NULL))  num = atoi(token);
		else ans = 2;
		if ((num > 0)&&(num < 16)) com_req_mode = num ;
		else ans = 2;
		com_req_mode = num ;
		break;
	
	case 2:  // $USER:user SIO_UDP
		p1 = 9000;	// UDP port no
		p2 = 38400;	// SIO speed
		p3 = 0;		// (Reserved)
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,"0123456789 \t") == NULL))  num = atoi(token);
		else ans = 2;
		if (num >= 1000) p1 = num;
		else ans = 2;
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,"0123456789 \t") == NULL))  num = atoi(token);
		else ans = 3;
		if ((num==9600)||(num==19200)||(num==38400)||(num==57600)||(num==115200))
			p2 = num;
		else ans = 3;
		token = strtok( NULL, delimter);
		strcpy(com_port,"");
		if (token != NULL)  {
			strcpy(com_port_, token); 
			if (strncmp(token, "com", 3)==0) strcpy(com_port, token);
		}
		else ans = 4;
		if (ans == 0) {
			com_req_mode = 5;
			udp_port  = p1;
			sio_speed = p2;
			TPJT_set_rSIO_para( udp_port, sio_speed );
		}
		break;
[Ver 2.00] */	
	case 3:	// $BATT:@obe[d@0%, 100%
		p1 = 65;
		p2 = 75;
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,"0123456789 \t") == NULL))  num = atoi(token);
		else ans = 2;
		if (num < 160) p1 = num;
		else ans = 2;
		token = strtok( NULL, delimter);
		if ((token != NULL)&&(_strspnp( token ,"0123456789 \t") == NULL))  num = atoi(token);
		else ans = 3;
		if ((num < 160)&&(num > p1)) p2 = num;
		else ans = 3;
		Batt_min = p1;
		Batt_max = p2;
		break;
	
	default:
		ans = 1;
		break;
	}
	return (ans);
}

/** o̓foCX ` ֐
 * @fn     int set_def_IO( char* msg)
 * @param  msg  : p[^̃|C^
 * @retval == 0 : OK
 * @retval >  0 : NG (error parameter no)
 *
 */
static int set_def_IO( char* msg)
{
	char* token;
	char dv_name[16];
	int  min;
	int  max;
	int  dzone;
	int  id = -1;
	int  ans = 0;

	token = strtok( msg , delimter);	// Pp[^擾ifoCXj
	if (token != NULL) sscanf(token,"%8s",dv_name);
	id = get_dev_id( dv_name );		// foCX  ID
	if (id == -1) return (1);
	if (dev_p[id] == 0 ) return (1);	// foCXo^H
	token = strtok( NULL, delimter);	// Qp[^擾iŏlj
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) {	// p[^`FbN
		min = atoi( token);
		dev_p[id]->set_min( min ) ;		// foCX̍ŏlZbg
	}
	else ans = 2;
	token = strtok( NULL, delimter);	// Rp[^擾iőlj
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) {	// p[^`FbN
		max = atoi( token);
		dev_p[id]->set_max( max ) ;		// foCX̍őlZbg
	}
	else ans = 3;
	token = strtok( NULL, delimter);	// Sp[^擾isђlj
	if (token != NULL) {
		if (_strspnp( token ,"-0123456789 \t") == NULL)  { 	// p[^`FbN
			dzone = atoi( token);
			dev_p[id]->set_dzone( dzone ) ;	// foCX̕sђlZbg
		}
		else ans = 4;
	}
	return (ans);
}

/** ̓foCXǉo^iYtj֐
 * @@@@@@@̓foCXɑ΂āAY@\tB
 * @fn     void in_dev_ent(IO_ctrl* p, int n)
 * @param  p    : ̓̓foCXENXInstance
 * @param  n    : Y(0 ` 3)
 *
 */
static void in_dev_ent(IO_ctrl* p, int n)
{
	int pos;
	int j = max_dev_no;

	if (( n < 0 )||( n > 3 ))	return ;
	if ( p == NULL ) return ;
	pos = p->get_pos();
	if (pos == -1) return ;
	switch(p->get_dv_type())
	{
	case AXIS_:
		dev_p[j]    = new AXIS_ctrl;
		break;
	case BUTT_:
		dev_p[j]    = new BUTT_ctrl;
		break;
	case POV_:
		dev_p[j]    = new POV_ctrl;
		break;
	default:
		break;
	}
	if ( dev_p[j] != 0 ) { 
		*dev_p[j] = *p;		// Copy class
		dev_p[j]->set_dev_n( n ); // Change acttion control mode no
		in_dev_p[pos][n] = j;
		max_dev_no++;
	}
}

/** Yt́@` ֐
 * @fn     int set_arry( char* msg)
 * @param  msg  : p[^̃|C^
 * @retval == 0 : OK
 * @retval >  0 : NG (error parameter no)
 *
 */
static int set_arry( char* msg)
{
	char* token;
	char dv_name[16];
	int  id = -1;
	int  i;
	int  n;
	int ans = 0;

	token = strtok( msg , delimter);
	if (token != NULL) sscanf(token,"%8s",dv_name);
	id = get_dev_id( dv_name );
	if (id == -1) return (1);
	if (dev_p[id] == 0 ) return (1);
	if (dev_p[id]->get_dv_type() >= 10 ) return (1); // Output Device ?
	token = strtok( NULL, delimter);
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) {
		n = atoi( token);
		if (( n < 1 )||( n > 4 )) ans = 2; // YFP`S
	}
	else ans = 2;

	if ( ans == 0 ) {
		dev_p[id]->set_dev_n(0);
		for ( i = 1; i < n ; i++ ) {
			in_dev_ent( dev_p[id], i);
		}
	}
	return (ans);
}

/** ZT[ ch o֐
 * @@@@@ZT[o^e[uAΉĂZT[choB
 * @fn     int get_ai_id( char* var_nm)
 * @param  var_nm : ZT[ |C^
 * @retval == -1  : ΉZT[Ȃ
 * @retval >= 0   : ΉZT[
 *
 */
static char def_AI_nm [][8] = {		// ZT[o^e[u
	 "AI01","AI02","AI03","AI04","AI05","AI06","AI07","AI08"
	,"AI09","AI10","AI11","AI12","PI01","PI02","PI03","PI04"
	,"" };	
static int get_ai_id( char* var_nm)
{
	int  i;
	int  ans;

	i = 0;
	ans = -1;
	while ( strlen(&def_AI_nm[i][0]) != 0 )
	{
		if (strcmp(&def_AI_nm[i][0],var_nm)== 0) {
			ans = i;
			break;
		}
		i++;
	}
	return(ans);
}

/** ͒l\ ` ֐
 * @fn     int set_dsp_ent( char* msg)
 * @param  msg  : p[^̃|C^
 * @retval == 0 : OK
 * @retval >  0 : NG (error parameter no)
 *
 */
static int set_dsp_ent( char* msg)
{
	char* token;
	char name[16];
	int  min, max;
	int  x, y, w, h;
	int  dsp_mode;
	int  ch;
	IO_dsp* p;
	int  ans;

	dsp_mode = 0; ans = 0;
	token = strtok( msg , delimter);		// get device name
	if (token != NULL) sscanf(token,"%8s",name);
	else return 1;
	ch = get_ai_id( name );
	if (ch < 0) return 1;
	token = strtok( NULL, delimter);		// get display name
	if (token != NULL) {
		sscanf(token,"%8s",name);
		p = ent_io_dsp();
		if (p) {
			p->init( ch, name );
			dsp_mode = p->dsp_mode;
			x = 0; y = 200; w = 150; h = 60; min = 10; max = 100;	// ftHglݒ
		}
		else return 1;
		
	}
	else return 2;

	token = strtok( NULL, delimter);	// \ʒu (x)
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL))  x = atoi( token);
	else ans = 3;
	token = strtok( NULL, delimter);	// \ʒu (y)
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL))  y = atoi( token);
	else ans = 4;
	token = strtok( NULL, delimter);	// \
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL))  w = atoi( token);
	else ans = 5;
	token = strtok( NULL, delimter);	// \
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) {
		h = atoi( token);
		p->set_pos( x, y, w, h);
	}
	else ans = 6;

	token = strtok( NULL, delimter);	// Ou\ 
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL))  min = atoi( token);
	else ans = 7;
	token = strtok( NULL, delimter);	// Ou\ 
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) {
		max = atoi( token);
		if (dsp_mode == 1) p->set_pi_para( min, max );
		else p->set_minmax( min, max );
	}
	else ans = 8;
	return (ans);
}

/** ANV` ֐
 * @fn     int set_def_act(char* msg)
 * @param  msg  : p[^̃|C^
 * @retval == 0 : OK
 * @retval >  0 : NG (error parameter no)
 *
 */
static int set_def_act(char* msg)
{
	char* token;
	char idv_nm[16] = "";
	char odv_nm[16] = "";
	int  id;
	int  coeff;
	int  init_v;
	int  type = 'R';
	int  ok;
	int  ans = 0;

	ok = 0; coeff = 1; init_v =127; type = 'R';		// ftHglݒ
	token = strtok( msg , delimter);
	if (token != NULL) sscanf(token,"%s",idv_nm);	// ̓foCX
	else ans = 1;
	token = strtok( NULL, delimter);
	if (token != NULL) sscanf(token,"%s",odv_nm);	// o̓foCX
	else ans = 2;
	token = strtok( NULL, delimter);
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL)) coeff = atoi( token);	// 萔
	else ans = 3;
	token = strtok( NULL, delimter);
	if ((token != NULL)&&(_strspnp( token ,"-0123456789 \t") == NULL))  init_v = atoi( token);	// l
	else ans = 4;
	token = strtok( NULL, delimter);
	if (token != NULL) {
		if (_strspnp( token ,"CDEFHR \t") == NULL) sscanf(token,"%1s",&type);	// ANVE^Cv
		else ans = 5;
	}

	if (XCHG_max_cnt< MAX_XCHG_NO)
	{
		id = get_dev_id( idv_nm );
		if ((id != -1)&&(dev_p[id] != 0 ))		// ̓foCX̃`FbN
		{
			xchg_p[XCHG_max_cnt] = new XCHG_ctrl;		// o̓f[^NXo^
			xchg_p[XCHG_max_cnt]->in_dev = dev_p[id];	// ̓foCXo^

			id = get_dev_id( odv_nm );
			if ((id != -1)&&(dev_p[id] != 0 ))	// o̓foCX̃`FbN
			{
				xchg_p[XCHG_max_cnt]->out_dev = dev_p[id];		// o̓foCXo^
				xchg_p[XCHG_max_cnt]->coeff    = coeff;			// 萔 o^
				xchg_p[XCHG_max_cnt]->init_vol = init_v;		// l o^
				xchg_p[XCHG_max_cnt]->type     = type;			// ANVE^Cv o^
				xchg_p[XCHG_max_cnt]->out_dev->set_vol(init_v);	//o̓foCXɏlZbg
				XCHG_max_cnt++;
				ok = 1;
			}
			else ans = 2;
		}
		else ans = 1;
		if (ok == 0)	//	o^G[
		{
			if (xchg_p[XCHG_max_cnt] != NULL)
			{
				delete(xchg_p[XCHG_max_cnt]);	// o̓f[^NX폜
				xchg_p[XCHG_max_cnt] = 0;
			}
		}
	}
	return (ans);
}


/** RtBO[VEt@C ݒ菈
 * @fn     int dev_config(char* F_name)
 * @param  F_name : t@C
 * @retval == 0   : OK
 * @retval == -1  : NG 
 *
 */
int dev_config(char* F_name)
{
	FILE *stream;
	char   rd_msg[256];
	char   rd_msg_s[256];
	char*  res;
	int    ans;

	err_log = fopen ( err_log_name, "w");	// create error log file

	stream = fopen( F_name, "r" );
	if( stream == NULL )	// Open ERROR
	{
		fprintf(err_log, "Open error <%s>!\n", F_name);
		fclose(err_log);
		return -1;
	}

	res = (char*)-1;
	while ( res != NULL)
	{
		res = fgets(rd_msg,255,stream);
		if (res == NULL) break;
		str_cut(rd_msg,"\n");
		str_cut(rd_msg,"//");
		strcpy(rd_msg_s,rd_msg);	// save message

		switch( rd_msg[0])
		{
		case '#':		// o͒`
			ans = set_def_IO( &rd_msg[1] );
			break;

		case '%':		// Yt́@`
			ans = set_arry( &rd_msg[1] );
			break;

		case '$':		// ϐ `
			ans = set_in_var( &rd_msg[1] );
			break;

		case '@':		//	AiO͒l@\ `
			ans = set_dsp_ent( &rd_msg[1] );
			break;

		case 0:
			ans = 0;
			break;

		default:		// {^EANV`
			ans = set_def_act(rd_msg);
			break;
		}
		if (ans) fprintf(err_log, "[ %s ] --> %dԖڂ̈ error \n", rd_msg_s, ans);
	}
	fclose(err_log);
	fclose(stream);
	return 0;

}


/** foCXE^Cv o֐
 * @@@@@foCXE^Cv e[uAΉĂfoCXE^CvIDoB
 * @fn     int get_dev_type_id( char* nm)
 * @param  nm     : foCXE^Cv |C^
 * @retval == -1  : Ή^CvȂ
 * @retval >= 0   : Ή^Cv
 *
 */
static char def_type_nm [][8] = { "AXIS_","BUTT_","POV_","" };	// foCXE^Cv e[u
static int get_dev_type_id( char* nm)
{
	int  i;
	int  ans;

	i = 0;
	ans = -1;
	while ( strlen(&def_type_nm[i][0]) != 0 )
	{
		if (strcmp(&def_type_nm[i][0],nm)== 0) {
			ans = i;
			break;
		}
		i++;
	}
	return(ans);
}

static void set_tbl(char* msg)
{
	char* token;
	char dev_nm[16] = "";
	char type_nm[16] = "";
	int  type_no;
	int  ch;

	token = strtok( msg , delimter);
	if (token != NULL) sscanf(token,"%8s",dev_nm);
	token = strtok( NULL, delimter);
	if (token != NULL) sscanf(token,"%s",type_nm);
	token = strtok( NULL, delimter);
	if (token != NULL)  ch = atoi( token);

	if (in_dev_name_cnt <= IN_DEV_MAX)
	{
		if ( strlen(dev_nm) == 0)  return;
		type_no = get_dev_type_id(type_nm);
		if ((type_no < 0)||(type_no > 3))  return;
		if ((type_no == AXIS_)&&(ch > 7))  return;
		if ((type_no == BUTT_)&&(ch > 19)) return;
		if ((type_no == POV_ )&&(ch > 15)) return;
		strcpy(&in_dev_name[in_dev_name_cnt].name[0], dev_nm);
		in_dev_name[in_dev_name_cnt].n       = -1;
		in_dev_name[in_dev_name_cnt].dv_type = type_no;
		in_dev_name[in_dev_name_cnt].ch_no   = ch;
		in_dev_name_cnt++;
	}
}


/** Rg[EIvV`t@C ݒ菈
 * @fn     int dev_tbl_config(char* F_name)
 * @param  F_name : t@C
 * @retval == 0   : OK
 * @retval == -1  : NG 
 *
 */
int dev_tbl_config(char* F_name)
{
	FILE *stream;
	char   rd_msg[256];
	char*  res;

	stream = fopen( F_name, "r" );
	if( stream == NULL )	// Open ERROR
	{
		return -1;
	}

	res = (char*)-1;
	while ( res != NULL)
	{
		res = fgets(rd_msg,255,stream);	// PsɓǏo
		if (res == NULL) break;
		str_cut(rd_msg,"\n");	// sR[h()
		str_cut(rd_msg,"//");	// Rg()

		set_tbl(rd_msg);		// IvV`

	}
	if ((in_dev_name_cnt > 0)&&(in_dev_name_cnt <= IN_DEV_MAX)) {
		strcpy(&in_dev_name[in_dev_name_cnt].name[0], "");	// `e[ȕI}[N
		in_dev_name[in_dev_name_cnt].n       = -1;
		in_dev_name[in_dev_name_cnt].dv_type = -1;
		in_dev_name[in_dev_name_cnt].ch_no   = -1;
		in_dev_name_cnt++;
	}
	else in_dev_name_cnt = 0;	// `e[uŜ𖳌ɂ

	fclose(stream);
	return 0;

}


/** foCXo^e[ȕ
 * @fn     int dev_init(void)
 * @retval == 0   : OK
 *
 */
int dev_init(void)
{
	int i,j;
	int pos ;

	memset( in_dev_p , -1, IN_DEV_MAX*4 );
	memset( out_dev_p, -1, OUT_DEV_MAX );
	memset( dev_p    ,  0, sizeof(IO_ctrl*)*(DEV_P_MAX));
	in_dev_name_cnt = 0;

	dev_tbl_config("def_game_ctrl.csv");	// Rg[EIvV`t@C ݒ菈
	if (in_dev_name_cnt == 0) {
		memcpy( in_dev_name, in_dev_default, max_in_dev_default_no * sizeof(DEF_DEV_t));	// ftHgݒ
		in_dev_name_cnt = max_in_dev_default_no ;
	}

// @̓foCXo^ ==> in_dev_p[]
	j = 0;
	for ( i = 0 ; i < (int)in_dev_name_cnt ; i++ )
	{
		dev_p[j]    = 0;
		if (in_dev_name[i].dv_type == -1) break;  // table end
		switch(in_dev_name[i].dv_type)
		{
		case AXIS_:
			dev_p[j]    = new AXIS_ctrl;
			break;
		case BUTT_:
			dev_p[j]    = new BUTT_ctrl;
			break;
		case POV_:
			dev_p[j]    = new POV_ctrl;
			break;
		default:
			break;
		}
		if ( dev_p[j] != 0 ) { 
			dev_p[j]->init( j, &in_dev_name[i] );
			pos = dev_p[j]->get_pos();
			in_dev_p[pos][0] = j;
			j++;
		}
	}


// @o̓foCXo^ ==> out_dev_p[]
	for ( i = 0 ; i < (int)out_dev_name_cnt ; i++ )
	{
		dev_p[j]     = 0;
		if (out_dev_name[i].dv_type == -1) break;  // table end
		switch(out_dev_name[i].dv_type)
		{
		case DCMT_:		// DC Motor
			dev_p[j]     = new DCMT_ctrl;
			break;
		case PWM_:		// PWM
			dev_p[j]     = new PWM_ctrl;
			break;
		case PWM2_:		// PWM
			dev_p[j]     = new PWM2_ctrl;
			break;
		case DO_:		// Degital output
			dev_p[j]     = new DO_ctrl;
			break;
		case VSEL_:		// Video(camera) Select output
			dev_p[j]     = new VSEL_ctrl;
			break;
		case VGA_:		// VGA/QVGA select
			dev_p[j]     = new VGA_ctrl;
			break;
		case MODE_:		// Action control mode
			dev_p[j]     = new MODE_ctrl;
			break;
		default:
			break;
		}
		if ( dev_p[j] != 0 ) { 
			dev_p[j]->init( j, &out_dev_name[i] );
			pos = dev_p[j]->get_pos();
			out_dev_p[pos] = j;
			j++;
		}
	}
	max_dev_no = j;
	return 0;
}

/** foCXo^e[ủ
 * @fn     void dev_relese(void)
 *
 */
void dev_relese(void)
{
	int i;

// Input device table
	for ( i = 0 ; i < IN_DEV_MAX ; i++ )
	{
		if (in_dev_p[i][0] != -1 ) 
		{
			in_dev_p[i][0] = -1;
			in_dev_p[i][1] = -1;
			in_dev_p[i][2] = -1;
			in_dev_p[i][3] = -1;
		}
	}

// Output device table
	for ( i = 0 ; i < OUT_DEV_MAX ; i++ )
	{
		if (out_dev_p[i] != -1 ) 
		{
			out_dev_p[i] = -1;
		}
	}

// All device table
	for ( i = 0 ; i < (int)max_dev_no ; i++ )
	{
		if (dev_p[i] != 0 ) 
		{
			delete(dev_p[i]);
			dev_p[i] = 0;
		}
	}
}

/** S̓foCX
 * @fn     void all_dev_in( void )
 *
 */
void all_dev_in( void )
{
	int i;
	IO_ctrl* p;

	for ( i = 0 ; i < IN_DEV_MAX ; i++ )
	{
		if ((p = get_in_dev_ptr(i)) != NULL ) 	p->inp();
	}
}

/** So̓foCX
 * @fn     void all_dev_out( void )
 *
 */
void all_dev_out( void )
{
	int i;
	IO_ctrl* p;

	for ( i = 0 ; i < OUT_DEV_MAX ; i++ )
	{
		if ((p = get_out_dev_ptr(i)) != NULL ) 	p->out();
	}
}


/** o̓f[^e[ȕ
 * @fn     void xchg_init(void)
 *
 */
void xchg_init(void)
{
	int i;

	XCHG_max_cnt = 0;
	for ( i = 0 ; i < MAX_XCHG_NO ; i++ )
	{
		xchg_p[i] = 0;
	}
}

/** o̓f[^e[ủ
 * @fn     void xchg_relese(void)
 *
 */
void xchg_relese(void)
{
	int i;

	for ( i = 0 ; i < MAX_XCHG_NO ; i++ )
	{
		if (xchg_p[i] != 0 ) 
		{
			delete(xchg_p[i]);
			xchg_p[i] = 0;
		}
	}
	XCHG_max_cnt = 0;
}

/** o̓f[^(action)
 * @fn     void xchg_act(void)
 *
 */
void xchg_act(void)
{
	int i;
	int i_vol;
	int o_vol;
	int a;
	int event;
	int type;
	int fade;
	int init_v;
	int n;

	for ( i = 0 ; i < XCHG_max_cnt ; i++ )
	{
		n = xchg_p[i]->in_dev->get_dev_n();
		if (( n == -1)||( n == act_mode )) {
			event = xchg_p[i]->in_dev->get_mode();
			i_vol = xchg_p[i]->in_dev->get_vol();
			o_vol = xchg_p[i]->out_dev->get_vol();
			a     = xchg_p[i]->coeff;
			type  = xchg_p[i]->type;
			fade  = xchg_p[i]->fade;
			init_v= xchg_p[i]->init_vol;
			if ( type == 'D') 	xchg_p[i]->out_dev->set_vol(i_vol * a); // Direct mode

			if ( type == 'E') {		// Edge mode 
				if (event == 1) xchg_p[i]->out_dev->add(i_vol * a);
			}
			if ( type == 'C') {		// Edge mode & Cyclic mode
				if (event == 1) xchg_p[i]->out_dev->addc(i_vol * a);
			}
			if((type == 'R')||(type == 'H')||(type == 'F')) {
				switch(event)
				{
				case 0:	// off
					if(fade != 0)
					{
						o_vol = xchg_p[i]->out_dev->add(fade);
						if (((fade > 0)&&(init_v < o_vol))||((fade < 0)&&(init_v > o_vol)))
						{
							xchg_p[i]->out_dev->set_vol(init_v);
							xchg_p[i]->fade = 0;
						}
					}
					break;
				case 1: // off -> on
					xchg_p[i]->fade = 0;
				case 2: // on
					xchg_p[i]->out_dev->add(i_vol * a);
					break;
				case 3: // on -> off
					if (type == 'F') {
						if (o_vol < init_v) {
							if (a > 0) xchg_p[i]->fade = a;
							else xchg_p[i]->fade = -a;
						}
						else {
							if (a > 0) xchg_p[i]->fade = -a;
							else xchg_p[i]->fade = a;
						}
					}
					else if (type != 'H') xchg_p[i]->out_dev->set_vol(init_v);
					break;
				default:
					break;
				}
			}
		}
	}
}